<?php	

/*******************************************
* SPMod
* Version 1.0
* © mamavrn.ru
********************************************
* SPPrintpage.php
*******************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function PrintReport()
{
	global $scripturl, $smcFunc, $context;
	checkSession();

	$context['robot_no_index'] = true;

	$context['report_real_name'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_real_name']), ENT_QUOTES);
	$context['report_summ'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_summ']), ENT_QUOTES);
	$context['report_org'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_org']), ENT_QUOTES);
	$context['report_bank'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_bank']), ENT_QUOTES);
	$context['report_tr'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_tr']), ENT_QUOTES);
	$context['report_summ'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_summ']), ENT_QUOTES);
	$context['report_distr'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_distr']), ENT_QUOTES);
	$context['report_payment'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_payment']), ENT_QUOTES);
	$context['report_orgname'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_orgname']), ENT_QUOTES);
	$context['report_orgnickname'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_orgnickname']), ENT_QUOTES);
	$context['report_procname'] = $smcFunc['htmltrim']($smcFunc['htmlspecialchars']($_POST['report_procname']), ENT_QUOTES);
	loadTemplate('SPPrintpage');
	loadLanguage('SPMod');
	$context['template_layers'] = array('print');
	
	foreach ($_POST['report_userid'] as $rui)
	{
		$request = $smcFunc['db_query']('', "
			SELECT 
				IFNULL(p1.orgpercent, " . $_POST['report_orgpercent'] . ") as orgpercent,
				m.real_name, 
				i.name, 
				i.price as price, 
				COUNT(*) as purchcount,         			
				SUM(i.price) as summa,
				GROUP_CONCAT(p2.param SEPARATOR ';') as params
			FROM {db_prefix}spmod_purchHis as p1
			LEFT JOIN {db_prefix}spmod_purchHis as p2 on p2.id = p1.id
			LEFT JOIN {db_prefix}members as m on m.id_member = p1.userid
			RIGHT JOIN {db_prefix}spmod_item as i on i.itemid = p1.itemid and i.status = 0
			WHERE p1.procid = {int:pr} AND p1.userid = {int:ui}
			GROUP BY p1.itemid
			ORDER BY purchcount DESC",
		array(
			'pr' => (int)$_POST['report_procid'],
			'ui' => $rui,
				)
			);		
		$i = 0;	
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			$orgsum = round($row['purchcount'] * $row['price']/100 * $row['orgpercent'], 2);			
			$banksum = round($row['purchcount'] *$row['price']/100 * $_POST['report_bankfee'], 2);
			$context['report_purchdetail'][$row['real_name']][] = array(
				'real_name' => $row['real_name'],
				'name' => $row['name'],
				'price' => $row['price'],
				'purchcount' => $row['purchcount'],
				'summa' => $row['summa'],
				'orgsum' => $orgsum,
				'banksum' => $banksum,			
				'params' => $row['params'],
				'vsego' => $row['summa'] + $orgsum + $banksum,
			);	
			$i++;	
		}
		$smcFunc['db_free_result']($request);
	}		
}

?>