<?php

/*******************************************
* SPMod
* Version 1.0
* © mamavrn.ru

********************************************
* Subs-SPMod.php
*******************************************/

if (!defined('SMF')) 
    die('Hacking attempt...');

//Статусы покупок
define('STATUS_OPEN', 0);   
define('STATUS_STOP', 1);   

function SPMod_load_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{
	global $context;
	loadLanguage('SPMod');
	$permissionList['membergroup'] += array(
		'view_spbuy' => array(false, 'spmod', 'view_basic_info'),
		'view_spmod' => array(false, 'spmod', 'administrate'),
		'view_spadmin' => array(false, 'spmod', 'administrate'),
	);
	
	$context['non_guest_permissions'] = array_merge(
		$context['non_guest_permissions'],
		array(
			'view_spmod',
			'view_spbuy',
			'view_spadmin',
		)
	);
}

function spmod_menu_buttons(&$buttons) 
{
	global $txt, $modSettings, $scripturl;
    
	loadLanguage('SPMod');	
	if (!isset($modSettings['spmenubutton_enabled'])) $modSettings['spmenubutton_enabled'] = '1';
	$counter = 0;
	foreach ($buttons as $name => $array) 
	{ 
	$counter++;
		if ($name == 'calendar') 
		break;
	} 
 
 	$subbuttons = array(
		'orginfo' => array( 
			'title' => $txt['spmod_info'], 
			'href' => $scripturl . '?action=spmod;sa=orginfo', 
			'show' => allowedTo(array('view_spbuy', 'view_spmod', 'view_spadmin')), 
			'sub_buttons' => array(), 
		),
		'spcat' => array( 
			'title' => $txt['spmod_cats'], 
			'href' => $scripturl . '?action=spmod;sa=spcat', 
			'show' => allowedTo(array('view_spmod', 'view_spadmin')), 
			'sub_buttons' => array(), 
		),		
		'goods' => array( 
			'title' => $txt['spmod_goods'], 
			'href' => $scripturl . '?action=spmod;sa=goods', 
			'show' => allowedTo(array('view_spmod', 'view_spadmin')), 
			'sub_buttons' => array(), 
		),		
		'proc' => array( 
			'title' => $txt['spmod_procurements'], 
			'href' => $scripturl . '?action=spmod;sa=proc', 
			'show' => allowedTo(array('view_spmod', 'view_spadmin')), 
			'sub_buttons' => array(), 
		),		
		'sizes' => array( 
			'title' => $txt['spmod_lines'], 
			'href' => $scripturl . '?action=spmod;sa=sizes', 
			'show' => allowedTo(array('view_spmod', 'view_spadmin')), 
			'sub_buttons' => array(), 
		),		
		'parser' => array( 
			'title' => $txt['spmod_parser'], 
			'href' => $scripturl . '?action=spmod;sa=parser', 
			'show' => allowedTo(array('view_spmod', 'view_spadmin')), 
			'sub_buttons' => array(), 
		),			
		'myproc' => array( 
			'title' => $txt['spmod_myproc'], 
			'href' => $scripturl . '?action=spmod;sa=myproc', 
			'show' => allowedTo(array('view_spbuy', 'view_spmod', 'view_spadmin')), 
			'sub_buttons' => array(), 
		),				
		'spadmin' => array( 
			'title' => $txt['spmod_spadmin'], 
			'href' => $scripturl . '?action=spmod;sa=spadmin', 
			'show' => allowedTo('view_spadmin'), 
			'sub_buttons' => array(), 
		),						
		'help' => array( 
			'title' => $txt['spmod_sphelp'], 
			'href' => $scripturl . '?action=spmod;sa=help', 
			'show' => true, 
			'sub_buttons' => array(), 
		),								
	);
 
	$buttons = array_merge( 
	array_slice($buttons, 0, $counter, true),
	array('spmod' => array( 
		'title' => $txt['spmenubutton_label'], 
		'href' => $scripturl . '?action=spmod', 
		'show' => $modSettings['spmenubutton_enabled'], 
		'sub_buttons' => $subbuttons, 
		)),
	array_slice($buttons, $counter, NULL, true) 
	);
}
function spmod_bbc_add_code(&$codes)
{
	$codes[] = array(
		'tag' => 'sp',                                                                             
		'type' => 'unparsed_content',
		'content' => '$1',
		'validate' => create_function('&$tag, &$data, $disabled', '       
			global $smcFunc, $context, $scripturl, $user_info, $txt; 
			LoadLanguage(\'SPMod\');
			if ( !isset($data) || !is_numeric($data))
			{
				$data = $txt[\'spmod_procnotfound\'];
			} else
			{	
				clean_cache();
				$request = $smcFunc[\'db_query\'](\'\', "
	SELECT orgpercent, minsum, orgid, status, bankfee, tr, topicid, minsum_mode
	FROM {db_prefix}spmod_proc
	WHERE procid = {int:pr}
	LIMIT 1
	",
					array(
						\'pr\' => $data,
					)
				);				
				$row = $smcFunc[\'db_fetch_assoc\']($request);
				$orgperc = $row[\'orgpercent\'];
				$minsum = $row[\'minsum\'];
				$minsummode = $row[\'minsum_mode\'];
				$org = $row[\'orgid\'];
				$stat = $row[\'status\'];
				$bankfee = $row[\'bankfee\'];
				$tr = $row[\'tr\'];
				$topic = $row[\'topicid\'];
				$smcFunc[\'db_free_result\']($request);
				
				if (!isset($org))
				{
					$data = $txt[\'spmod_procnotfound\'];
				}	
				else
				{
					$request = $smcFunc[\'db_query\'](\'\', "
						SELECT 
							p1.orgpercent as porg,
							p1.id, 
							p1.itemid, 
							p1.userid, 
							p1.status as purchstatus,
							i.status as itemstatus,
							m.real_name, 
							m.vk_id,
							i.name, 
							i.description, 
							i.image,	
							i.link,
							i.articul,
							i.price, 
							i.linecaption,
							SUM(i.price) as summa,
							COUNT(*) as purchcount,         
							concat(i.linecaption, \': \', GROUP_CONCAT(p2.param)) as params,
							l.linecount, 
							l.linecurrent,
							l.paramavail
						FROM {db_prefix}spmod_purchHis as p1
						LEFT JOIN {db_prefix}spmod_purchHis as p2 on p2.id = p1.id and p2.param != \'\'
						LEFT JOIN {db_prefix}members as m on m.id_member = p1.userid
						LEFT JOIN {db_prefix}spmod_item as i on i.itemid = p1.itemid
						LEFT JOIN {db_prefix}spmod_purchLines as l on l.id = p1.lineid
						WHERE p1.procid = {int:pr}
						GROUP BY p1.itemid, p1.userid, p1.lineid, p1.status
						ORDER BY userid",
					array(
						\'pr\' => (int)$data,
							)
						);		
					while ($row = $smcFunc[\'db_fetch_assoc\']($request))
					{
						if (isset($row[\'porg\'])) $op = $row[\'porg\']; else $op = $orgperc;
						$orgprice = $row[\'price\'] + $row[\'price\']/100 * $op;
						$orgsum = $row[\'summa\']	+ $row[\'summa\']/100*($orgperc+$bankfee);
						
						$purchases[] = array(
							\'id\' => $row[\'id\'],
							\'itemid\' => $row[\'itemid\'],
							\'userid\' => $row[\'userid\'],
							\'status\' => $row[\'itemstatus\'],
							\'purchstatus\' => $row[\'purchstatus\'],
							\'real_name\' => $row[\'real_name\'],
							\'name\' => $row[\'name\'],
							\'description\' => $row[\'description\'],
							\'image\' => $row[\'image\'],
							\'link\' => $row[\'link\'],
							\'articul\' => $row[\'articul\'],
							\'price\' => $row[\'price\'],
							\'orgprice\' => $orgprice,
							\'summa\' => $orgsum,
							\'purchcount\' => $row[\'purchcount\'],
							\'params\' => $row[\'params\'],
							\'linecount\' => $row[\'linecount\'],
							\'linecurrent\' => $row[\'linecurrent\'],
							\'caption\' => $row[\'linecaption\'],
							\'availparams\' => $row[\'paramavail\'],
							\'vk_id\' => $row[\'vk_id\'],
						);				
					}			
					$smcFunc[\'db_free_result\']($request);
					
					$outdata = \'\';					
					
					$request = $smcFunc[\'db_query\'](\'\', "
						SELECT 
							l.id,
							l.linecount, 
							l.linecurrent,
							l.paramavail,
							i.name,
							i.image,
							i.description,
							i.price,
							l.paramavail,
							i.linecaption,
							h.userid,
							i.itemid,
							i.params,
							GROUP_CONCAT(m.real_name) as username,
							GROUP_CONCAT(m.id_member) as userids,
							GROUP_CONCAT(h.param) as userparam
						FROM {db_prefix}spmod_purchLines as l
						RIGHT JOIN {db_prefix}spmod_purchHis as h on h.lineid = l.id AND h.procid = {int:pr}
						LEFT JOIN {db_prefix}spmod_item as i on h.itemid = i.itemid
						LEFT JOIN {db_prefix}members as m on m.id_member = h.userid
						WHERE l.id IS NOT NULL
						GROUP BY l.id
						",
					array(
						\'pr\' => (int)$data,
							)
						);					
					if ($smcFunc[\'db_num_rows\']($request) != 0)
					{
						//Таблица рядов
						$outdata = $outdata . \'<table style="border-collapse: collapse;" bgcolor="white" width="100%" cellpadding="5" cellspacing="5">
						<caption style="font-weight: bold;">\' . $txt[\'spmod_openlines\'] . \'</caption>\';
						$outdata = $outdata . \'<tr bgcolor="white">\';
						
						while ($row = $smcFunc[\'db_fetch_assoc\']($request))
						{			
							$openlines[] = array(
								\'id\' => $row[\'id\'],
								\'linecount\' => $row[\'linecount\'],
								\'linecurrent\' => $row[\'linecurrent\'],
								\'paramavail\' => $row[\'paramavail\'],
								\'name\' => $row[\'name\'],
								\'image\' => $row[\'image\'],
								\'description\' => $row[\'description\'],
								\'price\' => $row[\'price\'],
								\'paramavail\' => $row[\'paramavail\'],
								\'linecaption\' => $row[\'linecaption\'],
								\'userid\' => $row[\'userid\'],
								\'itemid\' => $row[\'itemid\'],
								\'params\' => $row[\'params\'],
								\'params\' => $row[\'params\'],
								\'username\' => $row[\'username\'],
								\'userids\' => $row[\'userids\'],
								\'userparam\' => $row[\'userparam\'],
							);
						}
						$rn = 1;
						foreach ($openlines as $openline)					
						{
							$outdata = $outdata . \'<td style="border: 1px solid black; text-align: center;">\';
							$outdata = $outdata . \'
							<figure style="height: 150px; float: center;border: 1px solid #333;padding: 7px;margin: 10px 0 5px 5px;background: #f0f0f0;">
							<figcaption style="margin: 0 auto 5px; font-weight: bold;">\'.$openline[\'name\'].\'</figcaption>							
							<p><img height="80" src="\';
													
							if (isset($openline[\'image\'])) $outdata = $outdata . $openline[\'image\'];
								else $outdata = $outdata . \'SPMod/images/sp/korob.png\';					
							
							$outdata = $outdata . \'" title="\'.$openline[\'description\'].\'" /></p>

							</figure>
							\';
							
							$ol = \'\';
							$ularr = explode(",", $openline[\'username\']);
							$ulidarr = explode(",", $openline[\'userids\']);

							//Если без параметров
							if (empty($openline[\'params\']))
							{
								$i = 0;
								foreach ($ularr as $ul) 
								{
									if ($i != 0) $ol = $ol . \'<br />\';
									$ol = $ol . \'<b><a href="/index.php?action=pm;sa=send;u=\'.$ulidarr[$i].\'">\' . $ul . \'</a></b>\';
									$i++;
								}
								$linkscount = $openline[\'linecount\'] - $openline[\'linecurrent\'];
								//Ряд не заполнен
								if ($linkscount != 0)									
								{
									for ($i = 1; $i <= $linkscount; $i++)
									{
										if ($i != 0) $ol = $ol . \'<br />\';
										$ol = $ol . \'<a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $openline[\'linecount\'] . \';goodid=\' . $openline[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\' . \'Заказать\' . \'</a>\';
									}	
								}
							}
							else
							//c параметрами сложнее...
							{
								$paarr = explode(",", $openline[\'userparam\']);		
								$allparams = explode(",", $openline[\'params\']);
								
								$i = 0;
								foreach ($allparams as $allparam)
								{	
									if ($i != 0) $ol = $ol . \'<br />\';
									$k = array_search($allparam, $paarr);	
									$ol = $ol .	$openline[\'linecaption\'] . \': \' . $allparam . \' \';
									if ($k !== false) 
									{
										$ol = $ol . \'<b><a href="/index.php?action=pm;sa=send;u=\'.$ulidarr[$k].\'">\' . $ularr[$k] . \'</a></b>\';
										unset($paarr[$k]);
									}	
									else
										$ol = $ol . \'<a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $openline[\'linecount\'] . \';goodid=\' . $openline[\'itemid\'] . \';pid1=\'.$allparam.\';sesc=\' . $context[\'session_id\'] . \'">\' . \'Заказать\' . \'</a>\';
									$i++;
								}
							}
														
//							$outdata = $outdata . $txt[\'spmod_t_price\'] . \'</td><td> \' . $openline[\'price\'] . \'
//							<br />\' . $txt[\'spmod_t_count\'] . \'</td><td>\' . $openline[\'linecurrent\'];
								
							$outdata = $outdata . \'<br />							
								<table cellspacing="0px" cellpadding="0" border="0">
									<tr>
									<td>\' . $txt[\'spmod_t_price\'] . \'</td><td> \' . $openline[\'price\'] . \'</td>
									</tr>
									<tr>
									<td>\'. $txt[\'spmod_t_count\'] . \'</td><td>\' . $openline[\'linecurrent\'] . \'</td>
									</tr>
								</table>\';
								
							$outdata = $outdata . \'<br />\' . $ol . \'</td>\';
																
							if ($rn%5 == 0) $outdata = $outdata . \'</tr><tr bgcolor="white">\';
								$rn++;
						}		
						$outdata = $outdata . \'</tr></table>\';
						//таблица рядов закрыта
					}					
					$smcFunc[\'db_free_result\']($request);													
					
					//Основная таблица заказов
					$outdata = $outdata . \'               
					<table style="border-collapse: collapse;" bgcolor="white" width="100%" cellpadding="5" cellspacing="5">
					<caption style="font-weight: bold;">\' . $txt[\'spmod_purctable\'] . \'</caption>
						<tr bgcolor="#D7CAB5">
						<th style="border: 1px solid black;">\'.\'№\'.\'</th>
						<th style="border: 1px solid black;">\'.$txt[\'spmod_username\'].\'</th>
						<th style="border: 1px solid black;">\'.$txt[\'spmod_pic\'].\'</th>
						<th style="border: 1px solid black;">\'.$txt[\'spmod_purchname\'].\'</th>
						<th style="border: 1px solid black;">\'.$txt[\'spmod_priceandcount\'].\'</th>
						<th style="border: 1px solid black;">\'.$txt[\'spmod_action\'].\'</th>
						</tr>\';
					$n = 1;	
					if (!empty($purchases)) foreach($purchases as $purch)
					{
						//Столбец "номер п.п."
						$outdata = $outdata . \'
						<tr bgcolor="white">
						<td style="border: 1px solid black; text-align: center;">\' .
						$n .
						\'</td>					
						<td style="border: 1px solid black; text-align: center;">\';
						if (isset($purch[\'vk_id\'])&& !empty($purch[\'vk_id\']))
							$outdata = $outdata . \'
							<b><a href="https://vk.com/id\'.$purch[\'vk_id\'].\'">\' . $purch[\'real_name\'] . \'</a></b>\';
						else
							$outdata = $outdata . \'
							<b><a href="/index.php?action=pm;sa=send;u=\'.$purch[\'userid\'].\'">\' . $purch[\'real_name\'] . \'</a></b>\';
						$outdata = $outdata . \'
						</td>
						<td style="border: 1px solid black; text-align: center;"><img height="80" src="\'; 
						
						if (isset($purch[\'image\'])) $outdata = $outdata . $purch[\'image\'];
							else $outdata = $outdata . \'SPMod/images/sp/korob.png\';
						if (!isset($purch[\'linecount\'])) $purch[\'linecount\'] = 0;
						if ($purch[\'linecount\'] == 0) $linecomplite = \'\';
							else
								if ($purch[\'linecount\'] == $purch[\'linecurrent\'])
									$linecomplite = \'<br /><b><span style="color: green;">\' . $txt[\'spmod_lineiscomplited\'] . \'</span>\' . $purch[\'linecurrent\'] . \'/\' . $purch[\'linecount\'] . \'</b>\';
								else 
								{
									$linecomplite = \'<br /><b><span style="color: red;">\' . $txt[\'spmod_lineisopened\'] . \'</span>\' . $purch[\'linecurrent\'] . \'/\' . $purch[\'linecount\'] . \'</b>\';

									if (empty($purch[\'availparams\']))
									{
										$linecomplite =	$linecomplite . \'<br /><a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\' . $txt[\'spmod_join\'] . \'</a>\';
									} else
									{
										$linecomplite =	$linecomplite . \'<br />\' . $txt[\'spmod_jointoline\'] . \' \' . $purch[\'caption\'] . \': \'; 
										$availparamsarray = explode(",", $purch[\'availparams\']);
										$paralinks = array();
										foreach ($availparamsarray as $availparam)
											array_push($paralinks, \'<a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';pid1=\' . $availparam . \';sesc=\' . $context[\'session_id\'] . \'">\' . $availparam . \'</a>\');
										$linecomplite =	$linecomplite . implode(",", $paralinks);
									}														
								}						
						$outdata = $outdata . \'" /></td>
						<td style="border: 1px solid black;">
						<a href="\'.$purch[\'link\'].\'" target="_blank">\' . $purch[\'name\'] . \'</a>\';
						
						if ($purch[\'description\'] != $purch[\'name\'])
							$outdata = $outdata . \'<br /><i>\' . $purch[\'description\'] . \'</i>\';
						
						$outdata = $outdata . \'
						<br />\' . $purch[\'params\'] . 
						$linecomplite . 
						\'
						</td>\';		
						$n++;
						if ($purch[\'status\'] == 0)
						{
							//Цены
							$outdata = $outdata . \'
							<td width="120px" style="border: 1px solid black;">
							<table cellspacing="0px" cellpadding="0" border="0">
								<tr>
								<td>\' . $txt[\'spmod_t_price\'] . \'</td><td> \' . $purch[\'price\'] . \'</td>
								</tr>
								<tr>
								<td>\' . $txt[\'spmod_t_org\'] . \'</td><td>\' . number_format($purch[\'orgprice\'], 2, \',\', \' \') . \'</td>
								</tr>
								<tr>
								<td>\'. $txt[\'spmod_t_count\'] . \'</td><td>\' . $purch[\'purchcount\'] . \'</td>
								</tr>
								<tr>
								<td>\' . $txt[\'spmod_t_summa\'] . \'</td><td><strong>\' . number_format($purch[\'summa\'], 2, \',\', \' \') . \'</strong></td>
								</tr>
							</table>\';					
							$onoff = \'<br /><a href="\' . $scripturl . \'?action=spmod;sa=no;procid=\' . (int)$data . \';userid=\' . $purch[\'userid\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_no\'].\'</a>\';
						}
						else
						{
							//Цены
							$outdata = $outdata . \'
							<td width="120px" style="border: 1px solid black;">
							<table cellspacing="0px" cellpadding="0" border="0">
								<tr>
								<td>\' . $txt[\'spmod_t_price\'] . \'</td><td> \' . $purch[\'price\'] . \'</td>
								</tr>
								<tr>
								<td>\' . $txt[\'spmod_t_org\'] . \'</td><td>\' . number_format($purch[\'orgprice\'], 2, \',\', \' \') . \'</td>
								</tr>
								<tr>
								<td>\'. $txt[\'spmod_t_count\'] . \'</td><td>\' . $purch[\'purchcount\'] . \'</td>
								</tr>
								<tr>
								<td>\' . $txt[\'spmod_t_summa\'] . \'</td><td style="text-decoration: line-through;">\' . number_format($purch[\'summa\'], 2, \',\', \' \') . \'</td>
								</tr>
							</table>\';							
							$onoff = \'<br /><a href="\' . $scripturl . \'?action=spmod;sa=yes;procid=\' . (int)$data . \';userid=\' . $purch[\'userid\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\' . $txt[\'spmod_yes\'] . \'</a>\';
							$outdata = $outdata . \'							
							<small><span style="color: red;">\' . $txt[\'spmod_no\'] . \'</span></small>
							\';
						}	
						
						$outdata = $outdata . \'
						</td>
						<td width="100px" style="border: 1px solid black; text-align: center;">\';						
						if (($user_info[\'id\'] == $org) || ($context[\'user\'][\'is_logged\'] && ($stat == $txt[\'spmod_purchaseopen\'] || $stat == $txt[\'spmod_purchstat_overorder\'])))
						{												
							//Если ты орг и это твой заказ
							if ($user_info[\'id\'] == $org && $user_info[\'id\'] == $purch[\'userid\'])
							{
								//Усли это ряд, то вместо ссылки "добавить", ссылки на свободные позиции в ряде
								if ($purch[\'linecount\'] != 0) 
									$buylink = \'\';
								else 
									$buylink = \'<br /><a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_add\'].\'</a>\';
								
								$outdata = $outdata . \'<a href="\' . $scripturl . \'?action=spmod;sa=editgood;goodid=\' . $purch[\'itemid\'] . \';topicid=\' . $topic . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_edit\'].\'</a>\'.
								$buylink .
								$onoff .
								\'<br /><a href="\' . $scripturl . \'?action=spmod;sa=oneunbuy;procid=\' . (int)$data . \';userid=\' . $user_info[\'id\'] . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'" onclick="return confirm(\\\'\' . $txt[\'spmod_onebuydelconf\'] . \'\\\');">\'.$txt[\'spmod_decrement\'].\'</a>\'.							
								\'<br /><a href="\' . $scripturl . \'?action=spmod;sa=unbuy;procid=\' . (int)$data . \';userid=\' . $user_info[\'id\'] . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'" onclick="return confirm(\\\'\' . $txt[\'spmod_buydelconf\'] . \'\\\');">\'.$txt[\'spmod_delete\'].\'</a>\';
							}
							//Если ты орг 
							else if ($user_info[\'id\'] == $org)
							{														
								//Усли это ряд, то вместо ссылки "добавить", ссылки на свободных позициях в ряде
								if ($purch[\'linecount\'] != 0) 
									$buylink = \'\';
								else 
									$buylink = \'<br /><a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_ordertoo\'].\'</a>\';
								
								$outdata = $outdata . \'<a href="\' . $scripturl . \'?action=spmod;sa=editgood;goodid=\' . $purch[\'itemid\'] . \';topicid=\' . $topic . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_edit\'].\'</a>
								<br /><a href="\' . $scripturl . \'?action=spmod;sa=delbuy;procid=\' . (int)$data . \';userid=\' . $purch[\'userid\'] . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'" onclick="return confirm(\\\'\' . $txt[\'spmod_buydelconf\'] . \'\\\');">\'.$txt[\'spmod_delete\'].\'</a>\'.
								$onoff . $buylink;						
							}		
							//Если ты не орг, но это твоя покупка
							else if ($user_info[\'id\'] == $purch[\'userid\'])		
							{
								//Усли это ряд, то вместо ссылки "добавить", ссылки на свободных позициях в ряде
								if ($purch[\'linecount\'] != 0) 
									$buylink = \'Ряд\';
								else 
									$buylink = \'<br /><a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_add\'].\'</a>\';
								
								$outdata = $outdata . $buylink;
								//Но если это закрытый ряд или уже был стоп, то отказываться нельзя. 
								if ((($purch[\'linecount\'] == 0) || ($purch[\'linecount\'] > $purch[\'linecurrent\'])) && ($purch[\'purchstatus\'] == STATUS_OPEN))
								$outdata = $outdata . \'
							<br /><a href="\' . $scripturl . \'?action=spmod;sa=oneunbuy;procid=\' . (int)$data . \';userid=\' . $user_info[\'id\'] . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_decrement\'].\'</a>							
							<br /><a href="\' . $scripturl . \'?action=spmod;sa=unbuy;procid=\' . (int)$data . \';userid=\' . $user_info[\'id\'] . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'" onclick="return confirm(\\\'\' . $txt[\'spmod_buydelconf\'] . \'\\\');">\'.$txt[\'spmod_refuse\'].\'</a>\';
							}
							
							//Ты простой пользователь	
							else 
							{
								//Усли это ряд, то вместо ссылки "добавить", ссылки на свободных позициях в ряде
								if ($purch[\'linecount\'] != 0) 
									$buylink = $txt[\'spmod_line\'];
								else 
									$buylink = \'<a href="\' . $scripturl . \'?action=spmod;sa=buy;procid=\' . (int)$data . \';lc=\' . $purch[\'linecount\'] . \';goodid=\' . $purch[\'itemid\'] . \';sesc=\' . $context[\'session_id\'] . \'">\'.$txt[\'spmod_metoo\'].\'</a>\';
								$outdata = $outdata . $buylink; 	
							}
						} else $outdata = $outdata . \'<font color="grey">\'.$txt[\'spmod_notavailable\'].\'</font>\';
						$outdata = $outdata . \'</td>
						</tr>\'; 		
					}
					if (allowedTo(\'view_spbuy\')&&($stat == $txt[\'spmod_purchaseopen\'] || $stat == $txt[\'spmod_purchstat_overorder\']))
					{	
						$outdata = $outdata . \'
					<tr bgcolor="#D7CAB5"><td colspan="6" style="text-align: center; border: 1px solid black;"><b>\' . $txt[\'spmod_orderstring\'] . \'</b></td></tr>
					<tr>
					<td style="text-align: center; border: 1px solid black;">\' . $n . \'</td>
					<td style="text-align: center; border: 1px solid black;"><b><a href="/index.php?action=pm;sa=send;u=\' . $user_info[\'id\'] . \'">\' . $user_info[\'name\'] . \'</a></b></td>
					<td style="border: 1px solid black;">
								
					\'. $txt[\'spmod_link\'] . \'<br /><input type="text" id="good_link"></td>
					  <td style="border: 1px solid black;">\' . $txt[\'spmod_os_name\'] . \'<br /><input size="30" type="text" id="good_name"></td>
					  <td style="border: 1px solid black;">\'.$txt[\'spmod_os_price\'].\'<br /><input type="text" id="good_price"></td>
					  <td style="text-align: center; border: 1px solid black;"><input type="button" value="\'.$txt[\'spmod_os_order\'].\'" class="button_submit" onclick="addOrder(\\\'\' . $scripturl . \'?action=spmod;sa=addandbuy;procid=\' . (int)$data . \';sesc=\' . $context[\'session_id\'] . \'\\\')"></td>
					  </tr>\';
					}
					$outdata = $outdata . \'</table><br />\';
					//Основная таблица покупок закрыта		
					
					$request = $smcFunc[\'db_query\'](\'\', "
						SELECT 
						SUM(i.price) as totalsum, COUNT(i.price) as totalcount
						FROM {db_prefix}spmod_purchHis as p1
						LEFT JOIN {db_prefix}spmod_item as i on (i.itemid = p1.itemid) and (i.status <> 1)
						WHERE p1.procid = {int:pr}",
					array(
						\'pr\' => (int)$data,
						)
					);				
					$row = $smcFunc[\'db_fetch_assoc\']($request);
					$ttl = $row[\'totalsum\']; 
					$ttc = $row[\'totalcount\']; 
					$smcFunc[\'db_free_result\']($request);
					//Таблица итогов
					if ($minsum <> 0) 
					{
						if ($minsummode == 2)
						{
							$outdata = $outdata . \'<table><tr><td>\'.$txt[\'spmod_totalcount\'].\':</td><td>\';
							$outdata = $outdata . \'<strong><font color="red">\' . number_format($ttc, 0, \',\', \' \') . \' \' . $txt[\'spmod_itemcountlbl\'] . \'</font></strong></td></tr>\';			
							$outdata = $outdata . \'<tr><td>\'.$txt[\'spmod_collected\'].\':</td><td><strong>\'.round($ttc/$minsum*100).\'%</strong></td></tr>
					<tr><td>\'.$txt[\'spmod_stillneeded\'].\':</td><td><strong><font color="green">\' . max(0, $minsum - $ttc) . $txt[\'spmod_itemcountlbl\'] . \'</font></strong></td></tr>\';							
						}
						else
						{
							$outdata = $outdata . \'<table><tr><td>\'.$txt[\'spmod_totalsum\'].\':</td><td>\';
							$outdata = $outdata . \'<strong><font color="red">\' . number_format($ttl, 2, \',\', \' \') . \' \' . $txt[\'spmod_currency\'] . \'</font></strong></td></tr>\';			
							$outdata = $outdata . \'<tr><td>\'.$txt[\'spmod_collected\'].\':</td><td><strong>\'.round($ttl/$minsum*100).\'%</strong></td></tr>
					<tr><td>\'.$txt[\'spmod_stillneeded\'].\':</td><td><strong><font color="green">\' . number_format(max(0, $minsum - $ttl), 2, \',\', \' \') . \' \' . $txt[\'spmod_currency\'] . \'</font></strong></td></tr>\';
						}
						$outdata = $outdata . \'</table>\';
						//Таблица итогов закрыта
					}
					$data = $outdata;
				}	
			}
		')         
	);	
	
	$codes[] = array(
		'tag' => 'mysp',
		'type' => 'unparsed_content',
		'content' => '$1',
		'validate' => create_function('&$tag, &$data, $disabled', '       
			global $smcFunc, $context, $scripturl, $user_info, $txt; 
			LoadLanguage(\'SPMod\');
			
			if ( !isset($data) || !is_numeric($data))
			{
				$data = $txt[\'spmod_noorg\'];
			} else
			{				
				$request = $smcFunc[\'db_query\'](\'\', \'
	SELECT name, topicid
	FROM {db_prefix}spmod_proc
	WHERE (orgid = {int:or}) AND (status = "\' . $txt[\'spmod_purchstat_open\'] . \'")\'
	,
					array(
						\'or\' => (int)$data,
					)
				);		
				$outdata = array();				
				while ($row = $smcFunc[\'db_fetch_assoc\']($request))
				{
					$outdata[] = \'<a href="\' . $scripturl . \'/topic=\' . $row[\'topicid\'] . \'">\'.$row[\'name\'].\'</a>\';
				}
				$smcFunc[\'db_free_result\']($request);
				$data = implode("<br />", $outdata);
			}
		')         
	); 
		
	$codes[] = array(
		'tag' => 'spon',
		'after' => '',
		'before' => '',
		); 

	$codes[] = array(
		'tag' => 'spph',
		'after' => '',
		'before' => '',		
		); 
		
	$codes[] = array(
		'tag' => 'spst',
		'after' => '',
		'before' => '',		
		); 

	$codes[] = array(
		'tag' => 'sppc',
		'after' => '',
		'before' => '',		
		); 		
		
	$codes[] = array(
		'tag' => 'spfe',
		'after' => '',
		'before' => '',		
		); 

	$codes[] = array(
		'tag' => 'sptr',
		'after' => '',
		'before' => '',		
		); 		
		
	$codes[] = array(
		'tag' => 'sptm',
		'after' => '',
		'before' => '',		
		); 
		
	$codes[] = array(
		'tag' => 'spws',
		'after' => '',
		'before' => '',		
		); 

	$codes[] = array(
		'tag' => 'spsp',
		'after' => '',
		'before' => '',		
		); 	

	$codes[] = array(
		'tag' => 'spmi',
		'after' => '',
		'before' => '',		
		); 
		
	$codes[] = array(
		'tag' => 'sppn',
		'after' => '',
		'before' => '',		
		); 

	$codes[] = array(
		'tag' => 'sppd',
		'after' => '',
		'before' => '',		
		); 		

	$codes[] = array(
		'tag' => 'spcl',
		'after' => '',
		'before' => '',		
		); 				
		
	$codes[] = array(
		'tag' => 'spmm',
		'after' => '',
		'before' => '',		
		); 						
}	
		
function sp_action(&$actionArray) 
{
	$actionArray['spmod'] = array('SPMod.php', 'SPModMain');
	$actionArray['spprintpage'] = array('SPPrintpage.php', 'PrintReport');
}

function spmod_query_string($tourniquet)
{
	global $context, $modSettings, $txt;

	$fix = str_replace('{version}', $modSettings['spmod_version'], '<a href="http://mamavrn.ru/index.php?action=spmod;sa=help" target="_blank" class="new_win">'. $txt['spmod_title'] .' {version} &copy; 2015</a>');

if ((SMF == 'SSI' && empty($context['standalone'])) || empty($context['template_layers']) || WIRELESS || strpos($tourniquet, $fix) !== false)
		return $tourniquet;

	$finds = array(
		', Simple Machines LLC</a>',
		', <a href="http://www.simplemachines.org" title="Simple Machines" target="_blank" class="new_win">Simple Machines</a>',
		'class="copywrite"',
		'class="copyright"',
	);
	$replaces = array(
		', Simple Machines LLC</a><br />' . $fix,
		', <a href="http://www.simplemachines.org" title="Simple Machines" target="_blank" class="new_win">Simple Machines</a><br />' . $fix,
		'class="copywrite" style="line-height: 1em;"',
		'class="copyright" style="line-height: 1.5em;"',
	);

	$tourniquet = str_replace($finds, $replaces, $tourniquet);

	if (strpos($tourniquet, $fix) === false)
	{
		$fix = '<div style="text-align: center; width: 100%; font-size: x-small; margin-bottom: 5px;">' . $fix . '</div></body></html>';
		$tourniquet = preg_replace('~</body>\s*</html>~', $fix, $tourniquet);
	}

	return $tourniquet;
}

function spmod_settings(&$config_vars)
{
	global $txt, $modSettings;
    
	loadLanguage('SPMod');
	if (isset($config_vars[0])) $config_vars[] = array('title', 'spmod');  
	$config_vars[] = array('check', 'spmenubutton_enabled', 'subtext' => $txt['spmenubutton_enabled_sub']);
	$config_vars[] = array('text', 'spmod_spcats', 'subtext' => $txt['spmod_spcats_sub']);
	$config_vars[] = array('int', 'spmod_sparchive', 'subtext' => $txt['spmod_sparchive_sub']);
	$config_vars[] = array('check', 'spmod_premoderate', 'subtext' => $txt['spmod_premoderate_sub']);
	$config_vars[] = array('check', 'spmod_checkbanner', 'subtext' => $txt['spmod_checkbanner_sub']);
	$config_vars[] = array('int', 'spmod_catforbanner', 'subtext' => $txt['spmod_catforbanner_sub']);
	$config_vars[] = array('int', 'spmod_maxpercent', 'subtext' => $txt['spmod_maxpercent_sub']);
	$config_vars[] = array('int', 'spmod_commission', 'subtext' => $txt['spmod_commission_sub']);
	$config_vars[] = array('check', 'spmod_addaddress', 'subtext' => $txt['spmod_addaddress_sub']);
	$config_vars[] = array('large_text', 'spmod_proctemplate', 'subtext' => $txt['spmod_proctemplate_sub']);
	$config_vars[] = array('large_text', 'spmod_distriblist', 'subtext' => $txt['spmod_distriblist_sub']);
}

function ItemToDB($catid, $name, $description, $image, $price, $link, $articul, $linecount = 0, $params = '', $linecaption = '')
{
	global $smcFunc, $modSettings, $language, $boardurl;

	if (!isset($catid)) $catid = -1; //без каталога (добавлен пользователем из таблицы)
	
	if (!isset($image) || $image == '') $image = $boardurl . '/SPMod/images/sp/korob.png'; 
	if (!isset($price)) $price = 0; else str_replace(' ', '', $price);
	if (!isset($link)) $link = '#'; else
		if (!strstr($link,"://")) $link = "http://" . $link;
	if (!isset($articul)) $articul = 0; 
	//Если форум не utf, то конвертируем в win1251 
	$pos = strpos($language, 'utf');
	if ($pos === false) 
	{
		$name = iconv("utf-8", "windows-1251", $name);
		$description = iconv("utf-8", "windows-1251", $description);
	}	
	
	$smcFunc['db_insert']('',
		'{db_prefix}spmod_item',
		array(
			'name' => 'string-255', 
			'description' => 'string-255', 
			'image' => 'string-255', 
			'price' => 'float', 
			'catid' => 'int',
			'link' => 'string-255', 
			'articul' => 'string-255',
			'linecount' => 'int',
			'params' => 'string',
			'linecaption' => 'string-255',
		),
		array(
			$smcFunc['htmlspecialchars']($name, ENT_QUOTES),
			$smcFunc['htmlspecialchars']($description, ENT_QUOTES),
			$image, 
			floatval(str_replace(',', '.', $price)),
			$catid,
			$link,
			$articul,
			(int)$linecount,
			$params,
			$linecaption
		),
		array('')
	);	
	$goodid = $smcFunc['db_insert_id']('{db_prefix}spmod_item', 'itemid');
	if ($catid != -1)
		// Увеличить счетчик в категориях
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}spmod_category
			SET count = count + 1
			WHERE catid = {int:id}',
			array(
				'id' => $catid,
			)
		);
	return $goodid;		
}

?>