<?php

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF')) 
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

$hooks = array(
	'integrate_pre_include' => '$sourcedir/Subs-SPMod.php',
	'integrate_bbc_codes' => 'spmod_bbc_add_code',
	'integrate_actions' => 'sp_action',
	'integrate_general_mod_settings' => 'spmod_settings',
	'integrate_load_permissions' => 'SPMod_load_permissions', 	
	'integrate_menu_buttons' => 'spmod_menu_buttons',
);

if (!empty($context['uninstalling']))
	$call = 'remove_integration_function';
else
	$call = 'add_integration_function';

foreach ($hooks as $hook => $function)
	$call($hook, $function);

?>