<?php

/*******************************************

* SPMod
* Version 1.0
* © mamavrn.ru

********************************************
* SPMod.template.php
*******************************************/

function template_main()
{
	writeTabs();	
	AddCopyright();
}

function writeTabs() 
{
	global $context, $scripturl;
	
	if (isset($context['tab_links'])) 
	{
		echo '<div id="admin_bmenu"><ul class="dropmenu" id="dropdown_menu_1">';
		foreach ($context['tab_links'] as $link) 
		{
			if ($link['visible'])
			{		
				if ($link['action'] == $context['sa']) 
					echo '<li><a class="firstlevel active" href="' , $scripturl . '?action=spmod' , (!empty($link['action']) ? ';sa=' . $link['action'] : '') . '"><span class="firstlevel">', $link['label'], '</span></a></li>';
				else
					echo'<li><a class="firstlevel" href="' , $scripturl . '?action=spmod', (!empty($link['action']) ? ';sa=' . $link['action'] : '') . '"><span class="firstlevel">', $link['label'], '</span></a></li>';
			}	
		}
		echo'</ul></div>';
	}
}	

//Зона "Параметры"
function template_sizes()
{
	writeTabs();
	echo '<div style="clear: both;">';
	template_show_list('lines_list');	
	echo '</div>';
	ParamsEditForm('sizes', 'add');
	AddCopyright();			
}

function template_editsizes()
{
	writeTabs();	
	ParamsEditForm('editsizes', 'save');	
	AddCopyright();
}

//Зона "Каталоги"
function template_spcat()
{
	global $context, $scripturl, $txt;
	
	writeTabs();
	echo '
	<div style="clear: both;">
	<form action="', $scripturl, '?action=spmod;sa=spcat;do=del" method="post" enctype="multipart/form-data>';
	template_show_list('cat_list');	
	echo '
		<div class="floatright">
			<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
			<div class="additional_row" style="text-align: right;">
				<input type="submit" name="delete_spcats" value="', $txt['spmod_delcats'], '" onclick="return confirm(\'',$txt['spmod_delcatsconfirm'] ,'\');" class="button_submit" />
			</div>
		</div>
	</form>
	</div>'; 
	CatalogEditForm('spcat', 'add');

	//From CSV
	echo '<br />
<div id="load_csv">	                                                      
	<form action="', $scripturl, '?action=spmod;sa=fromcsv" name="fromcsv" id="fromcsv" method="post" enctype="multipart/form-data">
		<div class="cat_bar">
			<h3 class="catbg">' . $txt['spmod_loadcsv'] . '</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
			<div class="content">
				<dl class="settings">					
					<dt>
						<strong>' . $txt['spmod_name'] . ':</strong><br />
						<span class="smalltext">' . $txt['spmod_namedescr'] . '</span>
					</dt>
					<dd>					
						<input type="text" name="cat_name" size="30" tabindex="5" class="input_text" value="' . $context['spmod_curname'] . '" />
					</dd>
					<dt>
						<strong>' . $txt['spmod_file'] . ':</strong><br />
						<span class="smalltext">' . $txt['spmod_filefielddescr'] . '</span>
					</dt>
					<dd>							
						<input type="file" name="filename" size="30" tabindex="6" class="input_text" />
					</dd>						
				</dl>
				<div class="righttext">
					<input type="hidden" name="sc" value="' . $context['session_id'] . '" />				
					<input type="submit" name="add" value="' . $txt['spmod_load'] . '" onclick="return !isEmptyText(this.form.cat_name);" tabindex="7" class="button_submit" />
				</div>				
			</div>	
			<span class="botslice"><span></span></span>
		</div>
	</form>
</div>';						
	
	//From XML
	echo '<br />
<div id="load_cat">	                                                      
	<form action="', $scripturl, '?action=spmod;sa=fromxml" name="fromxml" id="fromxml" method="post" enctype="multipart/form-data">
		<div class="cat_bar">
			<h3 class="catbg">' . $txt['spmod_loadcat'] . '</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
			<div class="content">
				<dl class="settings">
					<dt>
						<strong>' . $txt['spmod_file'] . ':</strong><br />
						<span class="smalltext">' . $txt['spmod_xmlfilefielddescr'] . '</span>
					</dt>
					<dd>							
						<input type="file" name="filename" size="30" tabindex="8" class="input_text" />
					</dd>						
				</dl>
				<div class="righttext">	
					<input type="hidden" name="sc" value="' . $context['session_id'] . '" />				
					<input type="submit" name="add" value="' . $txt['spmod_load'] . '" onclick="return !isEmptyText(this.form.filename);" tabindex="9" class="button_submit" />
				</div>
			</div>	
			<span class="botslice"><span></span></span>					
		</div>
	</form>
</div>';						
		
	AddCopyright();		
}

function CatalogEditForm($saname, $doname)
{
	global $scripturl, $context, $txt;
	
	if (!isset($context['spmod_curname']))$context['spmod_curname'] = '';
	if (!isset($context['spmod_usercat']))$context['spmod_usercat'] = false;
	if (!isset($context['spitem_curparam1']))$context['spitem_curparam1'] = '';

	echo '
<div id="manage_boards" style="clear: both;">
	<form action="', $scripturl, '?action=spmod;sa=', $saname ,';do=', $doname, '" name="cats" id="cats" method="post">
		<div class="cat_bar">
			<h3 class="catbg">';
	if ($saname == 'spcat') echo $txt['spmod_createnewcat']; 
		else echo $txt['spmod_editcat']; 
	echo '
			</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
			<div class="content">
			<dl class="settings">
				<dt>
					<strong>' . $txt['spmod_name'] . ':</strong><br />
					<span class="smalltext">' . $txt['spmod_namedescr'] . '</span>
				</dt>
				<dd>					
					<input type="text" name="cat_name" size="30" tabindex="1" class="input_text" value="' . $context['spmod_curname'] . '" />
				</dd>	
				<dt>
					<strong>' . $txt['spmod_usercat'] . ':</strong><br />
					<span class="smalltext">' . $txt['spmod_usercatdescr'] . '</span>
				</dt>
				<dd>					
					<input type="checkbox" name="cat_user" tabindex="2" class="input_check" value="1"';
	if ($context['spmod_usercat']) echo 'checked="checked" ';
	echo '/>
				</dd>';										
	if (!empty($context['spmod_params'])) 															
	{ 
		echo '
				<dt>
					<strong>' . $txt['spmod_param1'] . ':</strong><br />
					<span class="smalltext">' . $txt['spmod_paramdescr'] . '</span>
				</dt>
				<dd>
					<select tabindex="3" name="good_param1" id="paramchoose">
						<option value="0">'.$txt['spmod_dontadd'].'</option>';
		foreach($context['spmod_params'] as $spparam)
		{
			echo '
						<option value="'.$spparam['paramid'].'" ';
			if ($spparam['paramid'] == $context['spitem_curparam1']) echo 'selected="selected"';
			echo '>'. $spparam['name'] . '</option>';	
		}	
		echo '
					</select>	
				</dd>';					
	}
	echo '
			</dl>	
			<div class="righttext">';
	if ($saname == 'editcat' && isset($context['spmod_curid']))
	echo '
				<input type="hidden" value="' . $context['spmod_curid'] . '" name="catid" />';
	echo '			
				<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
				<input type="submit" name="add" value="' . $txt['spmod_save'] . '" onclick="return !isEmptyText(this.form.cat_name);" tabindex="4" class="button_submit" />
			</div>
		</div>
		<span class="botslice"><span></span></span>
	</form>
</div>';						
}

function ParamsEditForm($saname, $doname)
{
	global $scripturl, $context, $txt;
	
	if (!isset($context['param_curname']))$context['param_curname'] = '';
	if (!isset($context['param_curcaption']))$context['param_curcaption'] = '';
	if (!isset($context['param_curparam']))$context['param_curparam'] = '';	
	if (!isset($context['param_linecount']))$context['param_linecount'] = '0';	
	
	echo '
<div id="manage_boards" style="clear: both;">  
	<form action="', $scripturl, '?action=spmod;sa=', $saname ,';do=', $doname, '" name="ParamEditForm" id="para" method="post">
		<div class="cat_bar">
			<h3 class="catbg">';
	if ($saname == 'sizes') echo $txt['spmod_addparams']; 
		else echo $txt['spmod_editparams']; 
	echo '
			</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
			<div class="content">
				<dl class="settings">
					<dt>
						<strong> ' . $txt['spmod_name'] . ':</strong><br />
						<span class="smalltext">' . $txt['spmod_paramsnamedescr'] . '</span>
					</dt>
					<dd>					
						<input type="text" name="param_name" size="30" tabindex="1" class="input_text" value="' . $context['param_curname'] . '" />
					</dd>						
					<dt>
						<strong> ' . $txt['spmod_linecount'] . ':</strong><br />
						<span class="smalltext">' . $txt['spmod_linecountdescr'] . '</span>
					</dt>
					<dd>					
						<input type="text" name="param_linecount" size="10" tabindex="2" class="input_text" value="' . $context['param_linecount'] . '" />
					</dd>					
					<dt>
						<strong>' . $txt['spmod_paramalias'] . ':</strong><br />
						<span class="smalltext">' . $txt['spmod_paramsdescr'] . '</span>
					</dt>
					<dd>					
						<input type="text" name="param_caption" size="30" tabindex="3" class="input_text" value="' . $context['param_curcaption'] . '" />
					</dd>					
					<dt>
						<strong>'.$txt['spmod_values'].':</strong><br />
						<span class="smalltext">'.$txt['spmod_valuesdescr'].'</span>
					</dt>
					<dd>					
						<textarea tabindex="4" rows="3" cols="30" name="param_param">' . $context['param_curparam'] . '</textarea>
					</dd>							
				</dl>	
				<div class="righttext">';
	if ($saname == 'editsizes' && isset($context['param_curid']))
	echo '
					<input type="hidden" value="' . $context['param_curid'] . '" name="paramid" />';
	echo '
					<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
					<input type="submit" name="add" value="'.$txt['spmod_save'].'" onclick="return !isEmptyText(this.form.param_name);" tabindex="5" class="button_submit" />
				</div>
			</div>	
			<span class="botslice"><span></span></span>
		</div>
	</form>
</div>';						
}

//Зона редактирования каталога	
function template_editcat()
{
	writeTabs();	
	CatalogEditForm('editcat', 'save');	
	AddCopyright();
}	

//Зона "Товары"
function template_goods()
{
	global $context, $scripturl, $txt, $boardurl; 
	
	writeTabs();

	echo '
	<form action="', $scripturl, '?action=spmod;sa=goods;sesc=', $context['session_id'], '" method="post" name="theCatalogChoose">
	<div class="content" style="clear: both;">
		<img src="', $boardurl, '/Themes/default/images/admin/logs.gif" class="icon" alt="'.$txt['spmod_catchoose'].'" /><span><label for="catname">'.$txt['spmod_curcat'].'   </label></span>
		<select name="catid" id="catname">';
	if (!empty($context['spmod_cats'])) foreach($context['spmod_cats'] as $spmod_name)
	{ 											
		echo '			<option value="'.$spmod_name['catid'].'" ';
		if (isset($context['spmod_curcat'])&&$spmod_name['catid'] == $context['spmod_curcat']) echo 'selected="selected"';
		echo '>'. $spmod_name['name'] . '</option>';
	}
	echo '
		</select>										
		<input type="submit" value="'.$txt['spmod_choose'].'" class="button_submit" />
	</div>
	</form>
	<div style="clear: both;">
	<form action="', $scripturl, '?action=spmod;sa=goods;do=del" method="post" enctype="multipart/form-data>';	
	template_show_list('good_list');
	echo '
		<div class="floatright">
			<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
			<div class="additional_row" style="text-align: right;">
				<input type="submit" name="delete_spgoods" value="', $txt['spmod_delgoods'], '" onclick="return confirm(\'',$txt['spmod_delgoodsconfirm'] ,'\');" class="button_submit" />
			</div>
		</div>
	</form>
	</div>'; 	
	GoodEditForm('goods', 'add');
	AddCopyright();
}

function GoodEditForm($saname, $doname)
{
	global $scripturl, $context, $txt, $boardurl;
		
	echo '	
<script src="', $boardurl, '/SPMod/jquery/external/jquery/jquery.js"></script>
<script src="', $boardurl, '/Themes/default/scripts/zoomsl-3.0.min.js"></script>
<script src="', $boardurl, '/Themes/default/scripts/spmod.js"></script>
<script>
jQuery(function(){   
	$(".goodzoom").imagezoomsl({    
		zoomrange: [3, 3]
	});
});  
</script>
<div id="manage_boards" style="clear: both;"> 
	<form action="', $scripturl, '?action=spmod;sa=',$saname ,';do=', $doname,'" method="post" name="theGoodForm" enctype="multipart/form-data">					
		<div class="cat_bar">
			<h3 class="catbg">';

	if ($saname == 'goods')
		echo $txt['spmod_additem'];
	else
		echo $txt['spmod_edititem'];	
	if (!isset($context['spitem_curname'])) $context['spitem_curname'] = '';
	if (!isset($context['spitem_curdesr'])) $context['spitem_curdesr'] = '';
	if (!isset($context['spitem_curimage'])) $context['spitem_curimage'] = $boardurl . '/SPMod/images/sp/korob.png';	
	if (!isset($context['spitem_curprice'])) $context['spitem_curprice'] = '';	
	if (!isset($context['spitem_curarticul'])) $context['spitem_curarticul'] = '';
	if (!isset($context['spitem_curlink'])) $context['spitem_curlink'] = '';
	
	if (!isset($context['spitem_curparam1'])) $context['spitem_curparam1'] = '';

	if (!isset($context['spitem_curlinecount'])) $context['spitem_curlinecount'] = 0;
	if (!isset($context['spitem_curparams'])) $context['spitem_curparams'] = '';
	if (!isset($context['spitem_curlinecaption'])) $context['spitem_curlinecaption'] = $txt['spmod_defaultcaption'];
	
	echo '
			</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
			<div style="text-align: center;float: left;">
				
			<br><br>
			<table border="0">
			<tr>
				<td width="10%">&nbsp;</td><td>
					<img class="goodzoom" style="width:220px" alt="',$txt['spmod_name'],'" src="', $context['spitem_curimage'] ,'" data-large="', $context['spitem_curimage'] ,'">
				</td><td width="10%">&nbsp;</td>
			</tr></table>	 				
					
			</div>		
			<div class="content">
				<dl class="settings">';
	if ($saname == 'editgood') 
	{
		echo '
				<dt>
					<strong>'.$txt['spmod_curcat'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_curcat'].'</span>
				</dt>
				<dd>
					<select name="catid" id="catname">';
		if (!empty($context['spmod_cats'])) foreach($context['spmod_cats'] as $spmod_name)
		{	 											
			echo '				<option value="'.$spmod_name['catid'].'" ';
			if (isset($context['spmod_curcat'])&&$spmod_name['catid'] == $context['spmod_curcat']) echo 'selected="selected"';
			echo '>'. $spmod_name['name'] . '</option>';
		}
		echo '
					</select>
				</dd>';
	} else
	{
		echo '
				<input type="hidden" name="catid" value="' . $context['spmod_curcat'] . '" />';
	}
	echo '				
				<dt>
					<strong>'.$txt['spmod_name'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_itemdescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="good_name" size="30" tabindex="1" class="input_text" value="'.$context['spitem_curname'].'" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_description'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_descriptiondescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="good_descr" size="30" tabindex="2" class="input_text" value="'.$context['spitem_curdesr'].'" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_articul'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_articuldescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="good_articul" size="30" tabindex="3" class="input_text" value="'.$context['spitem_curarticul'].'" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_imgurl'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_imgurldescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="good_img" size="30" tabindex="4" class="input_text" value="'.$context['spitem_curimage'].'" />
				</dd>	
				<dt>
					<strong>'.$txt['spmod_imgfile'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_imgfiledescr'].'</span>
				</dt>
				<dd>
					<input type="file" name="good_fileimg" tabindex="5" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_link'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_linkdescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="good_link" size="30" tabindex="6" class="input_text" value="'.$context['spitem_curlink'].'" />
				</dd>	
				<dt>
					<strong>'.$txt['spmod_price'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_pricedescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="good_price" size="30" tabindex="7" class="input_text" value="'.$context['spitem_curprice'].'" />
				</dd>						
				<dt>
					<strong>'.$txt['spmod_addingparam'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_addingparamdescr'].'</span>
				</dt>
				<dd>
					<select name="good_param1" id="paramchoose" onchange="if (this.selectedIndex != 0) 
					{
						var ar;
						ar = this.options[this.selectedIndex].value.split(\';\');
						document.getElementById(\'tx0\').value=ar[0];	
						document.getElementById(\'tx1\').value=ar[1];	
						document.getElementById(\'tx2\').value=ar[2];	
					}">					
					<option value="0">'.$txt['spmod_dontadd'].'</option>';
	if (!empty($context['spmod_params'])) foreach($context['spmod_params'] as $spparam)															
		echo '				<option value="'.$spparam['linecount'].';'.$spparam['caption'].';'.$spparam['params'].'">'. $spparam['name'] . '</option>';
	echo '
					</select>	
				</dd>';									
				
	echo '				
				<dt>
					<strong>'.$txt['spmod_linecount'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_linecountdescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="param_linecount" size="30" tabindex="8" class="input_text" value="'.$context['spitem_curlinecount'].'" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_paramalias'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_paramsdescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="param_caption" size="30" tabindex="9" class="input_text" value="'.$context['spitem_curlinecaption'].'" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_values'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_valuesdescr'].'</span>
				</dt>
				<dd>
					<textarea tabindex="10" rows="3" cols="30" name="param_param">' . $context['spitem_curparams'] . '</textarea>
				</dd>';					
			
	echo '		
				</dl>
				<div class="righttext">';
	if ($saname == 'editgood' && isset($context['spitem_curid']))
		echo '			<input type="hidden" value="'.$context['spitem_curid'].'" name="goodid" />';
	if (isset($context['spmod_curtopic']))
		echo '<input type="hidden" name="topicid" value="' . $context['spmod_curtopic'] . '" />';	
	echo '
					<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
					<input type="submit" name="add" value="' . $txt['spmod_save'] . '" onclick="return !isEmptyText(this.form.good_name);" tabindex="11" class="button_submit" />
				</div>
			</div>
			<span class="botslice"><span></span></span>	
		</div>		
	</form>
</div>';		
}

//Зона редактирования товара	
function template_editgood()
{
	writeTabs();                       
	GoodEditForm('editgood', 'save');
	AddCopyright();
}

function template_buy()
{
}

function template_changeop()
{
}

function template_addandbuy()
{
}

function template_pay()
{
}

function template_stopproc()
{
}

function template_closeproc()
{
}

function template_closeproc2()
{
}

function template_payproc()
{
}

//ОТКАЗАЛИСЬ
function template_unbuy()
{
	global $txt;
	echo '<br /><strong><center>' . $txt['spmod_orderunbay'] . '</center></strong><br />';
}

//ОТКАЗАЛИСЬ ОТ ОДНОГО
function template_oneunbuy()
{
	global $txt;
	echo '<br /><strong><center>' . $txt['spmod_orderunbay'] . '</center></strong><br />';
}

//ОРГ УДАЛИЛ (Добавить проверку-подтверждение)
function template_delbuy()
{
	global $txt;
	echo '<br /><strong><center>' . $txt['spmod_orderdel'] . '</center></strong><br />';
}

//НЕТ В НАЛИЧИИ
function template_no()
{
	global $txt;
	echo '<br /><strong><center>' . $txt['spmod_done'] . '</center></strong><br />';
}

//НЕТ В НАЛИЧИИ
function template_yes()
{
	global $txt;
	echo '<br /><strong><center>' . $txt['spmod_done'] . '</center></strong><br />';
}

//ОРГ ДОБАВИЛ
function template_addbuy()
{
	global $txt;
	echo '<br /><strong><center>'.$txt['spmod_addorder'].'</center></strong><br />';
}

//Зона "Закупки"
function template_proc()
{
	global $txt, $user_info;

	writeTabs();

	echo '
	<div style="clear: both;">';
	template_show_list('proc_list');
	echo '</div>';
	template_show_list('closed_proc_list');
	ProcEditForm('proc', 'add');

	echo '
	<br />
	<div id="manage_boards">	
		<div class="cat_bar">
			<h3 class="catbg">' . $txt['spmod_pastecode'] . '</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
			<div class="content">
				<br />
				<dl class="settings">
				<dt>
					<strong>'.$txt['spmod_yourproclistcode'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_yourproclistcodedescr'].'</span>
				</dt>
				<dd>		
					<textarea rows="3" cols="75" name="text">[b]' . $txt['spmod_mypurchase'] . ':[/b]
[mysp]' . $user_info['id'] . '[/mysp]</textarea>
				</dd>
				</dl>
			</div>
		</div>
		<span class="botslice"><span></span></span>
	</div>';	

	AddCopyright();
}

function ProcEditForm($saname, $doname)
{
	global $scripturl, $context, $boardurl, $txt, $user_info;
	echo ' 
	<!--	
	<link rel="stylesheet" href="', $boardurl, '/SPMod/jquery/themes/base/jquery-ui.css">
	-->
	<link rel="stylesheet" href="//code.jquery.com/ui/1.11.4/themes/smoothness/jquery-ui.css">
	<script src="', $boardurl, '/SPMod/jquery/external/jquery/jquery.js"></script>
	<script src="', $boardurl, '/SPMod/jquery/ui/widget.js"></script>
	<script src="', $boardurl, '/SPMod/jquery/ui/datepicker.js"></script>
	<script src="', $boardurl, '/SPMod/jquery/ui/i18n/datepicker.'.$user_info['language'].'.js"></script>	
	<script>
	$(function() {
		$( "#datepicker" ).datepicker( $.datepicker.regional[ "ru" ] );
	});
	</script>';		
	
	echo '
<div id="manage_boards" style="clear: both;">
	<form action="', $scripturl, '?action=spmod;sa=', $saname,';do=', $doname, '" method="post" name="theProcForm">					
		<div class="cat_bar">
			<h3 class="catbg">';
	if ($saname == 'proc')
		echo $txt['spmod_newpurchase'];
	else echo $txt['spmod_createpurchase'];

	$sp_statuses = array(
                 $txt['spmod_purchstat_open'],
                 $txt['spmod_purchstat_stop'],
                 $txt['spmod_purchstat_wait'],
                 $txt['spmod_purchstat_pay'],
                 $txt['spmod_purchstat_shipment'],
                 $txt['spmod_purchstat_overorder'],
                 $txt['spmod_purchstat_stopoverorder'],
                 $txt['spmod_purchstat_inway'],
                 $txt['spmod_purchstat_close'],
                 $txt['spmod_purchstat_gone'],
                 $txt['spmod_purchstat_get'],
                 $txt['spmod_purchstat_issuance'],
                 $txt['spmod_purchstat_vocation'],
				 $txt['spmod_purchstat_wasnt'],
	);

	if (!isset($context['spproc_curname']))$context['spproc_curname'] = '';
	if (!isset($context['spproc_curdesr']))$context['spproc_curdesr'] = '';
	if (!isset($context['spproc_curstop']))$context['spproc_curstop'] = time();
	if (!isset($context['spproc_curwebsite']))$context['spproc_curwebsite'] = '';
	if (!isset($context['spproc_curstatus']))$context['spproc_curstatus'] = $sp_statuses[0];
	if (!isset($context['spproc_curpercent']))$context['spproc_curpercent'] = 0;
	if (!isset($context['spproc_curmin']))$context['spproc_curmin'] = 0;
	if (!isset($context['spproc_curtopic']))$context['spproc_curtopic'] = 0;
	if (!isset($context['spproc_curfee']))$context['spproc_curfee'] = 0;
	if (!isset($context['spproc_curtr']))$context['spproc_curtr'] = 0;	
	if (!isset($context['spproc_curminsummode']))$context['spproc_curminsummode'] = 0;
	if (!isset($context['spproc_curbanner']))$context['spproc_curbanner'] = '';
	if (!isset($context['spproc_curbuyout']))$context['spproc_curbuyout'] = '1';
	
	echo '
			</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>
			<div class="content">
				<dl class="settings">
				<dt>
					<strong>'.$txt['spmod_name'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_purchname'].'</span>
				</dt>
				<dd>
					<input type="text" name="proc_name" size="30" tabindex="1" class="input_text" value="'.$context['spproc_curname'].'" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_description'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_purchnamedescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="proc_descr" size="30" tabindex="2" class="input_text" value="'.$context['spproc_curdesr'].'" />
				</dd>
				<dt>
					<strong>' . $txt['spmod_buyout']	.':</strong><br />
					<span class="smalltext">' . $txt['spmod_buyoutdescr'] . '</span>
				</dt>
				<dd>
					<input type="number" min="1" max="100" name="proc_buyout" size="30" tabindex="4" class="input_text" value="'.$context['spproc_curbuyout'].'" />
				</dd>					
				<dt>
					<strong>' . $txt['spmod_website']	.':</strong><br />
					<span class="smalltext">' . $txt['spmod_websitedescr'] . '</span>
				</dt>
				<dd>
					<input type="text" name="proc_website" size="30" tabindex="5" class="input_text" value="'.$context['spproc_curwebsite'].'" />
				</dd>					
				<dt>
					<strong>'.$txt['spmod_purchasestopdate'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_purchstopdescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="proc_stop" id="datepicker" maxlength="100" size="30" tabindex="6" class="input_text" value="'.date('j.m.Y', $context['spproc_curstop']).'" />
				</dd>	
				<dt>
					<strong>'.$txt['spmod_orgpercent'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_orgpercentdescr'].'</span>
				</dt>
				<dd>
					<select name="proc_orgpercent">';		
	foreach($context['sp_percent'] as $orgper)
	{
		echo '<option ';
		if ($orgper == $context['spproc_curpercent']) echo 'selected="selected" ';
		echo 'value="',$orgper ,'">', $orgper,'%</option>';
	}	
	$trmodech = array(); 
	if (!isset($context['spproc_curtrmode'])) $context['spproc_curtrmode'] = 0;
	for ($i = 1; $i <= 5; $i++) 
		if ($context['spproc_curtrmode'] == $i) $trmodech[$i] = 'selected="selected" ';
			else $trmodech[$i] = ' ';

	for ($i = 1; $i <= 2; $i++) 
		if ($context['spproc_curminsummode'] == $i) $minsummodech[$i] = 'selected="selected" ';
			else $minsummodech[$i] = ' ';	
	echo '
					</select>
				</dd>							
				<dt>
					<strong>' . $txt['spmod_bankfee'] . ':</strong><br />
					<span class="smalltext">' . $txt['spmod_bankfeedescr'] . '</span>
				</dt>
				<dd>
					<input type="text" name="proc_fee" size="10" tabindex="7" class="input_text" value="'.$context['spproc_curfee'].'" />
				</dd>
				<dt>
					<strong>' . $txt['spmod_tr'] . ':</strong><br />
					<span class="smalltext">' . $txt['spmod_trdescr'] . '</span>
				</dt>
				<dd>
					<select name="proc_tr_mode">
						<option value="1"' . $trmodech[1] . '>'.$txt['spmod_p_trmode1'].'</option>
						<option value="2"' . $trmodech[2] . '>'.$txt['spmod_p_trmode2'].'</option>
						<option value="3"' . $trmodech[3] . '>'.$txt['spmod_p_trmode3'].'</option>
						<option value="4"' . $trmodech[4] . '>'.$txt['spmod_p_trmode4'].'</option>
						<option value="5"' . $trmodech[5] . '>'.$txt['spmod_p_trmode5'].'</option>
					</select>
					<input type="text" name="proc_tr" size="10" tabindex="8" class="input_text" value="'.$context['spproc_curtr'].'" />
				</dd>					
				<dt>
					<strong>'.$txt['spmod_minsum'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_minsumdescr'].'</span>
				</dt>
				<dd>
					<select name="proc_minsum_mode">
						<option value="1"' . $minsummodech[1] . '>'.$txt['spmod_p_minsum'].'</option>
						<option value="2"' . $minsummodech[2] . '>'.$txt['spmod_p_mincount'].'</option>
					</select>					
					<input type="text" name="proc_min" size="10" tabindex="9" class="input_text" value="'.$context['spproc_curmin'].'" />
				</dd>
				<dt>
					<strong>'.$txt['spmod_topicid'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_topiciddescr'].'</span>
				</dt>
				<dd>	
					<input  type="hidden" name="proc_topic" class="input_text" value="'.$context['spproc_curtopic'].'" />
					<select name="proc_forum_category">';		
	foreach($context['sp_forum_categorylist'] as $sp_forum_category)
	{
		echo '<option ';
		if (isset($context['spproc_curboard']) && $sp_forum_category['id_board'] == $context['spproc_curboard']) echo 'selected="selected" ';
		echo 'value="',$sp_forum_category['id_board'] ,'">', $sp_forum_category['board_name'],'</option>';
	}	
	echo '
					</select>								
				</dd>
				<dt>
					<strong>' . $txt['spmod_status'] . ':</strong><br />
					<span class="smalltext">' . $txt['spmod_statusdescr'] . '</span>
				</dt>
				<dd>
					<select name="proc_status">';
	foreach($sp_statuses as $sps)
	{
		echo '<option ';
		if ($sps == $context['spproc_curstatus']) echo 'selected="selected" ';
		echo 'value="' . $sps . '">' . $sps . '</option>';
	}
	echo '
					</select>
				</dd>
				<dt>
					<strong>' . $txt['spmod_banner'] . ':</strong><br />
					<span class="smalltext">' . $txt['spmod_bannerdescr'] . '</span>
				</dt>
				<dd>
					<input type="text" name="proc_banner" size="30" tabindex="10" class="input_text" value="'.$context['spproc_curbanner'].'" />
				</dd>					
				<dt>
					<strong>'.$txt['spmod_cats'].':</strong><br />
					<span class="smalltext">'.$txt['spmod_catsdescr'].'</span>
				</dt>					
				<dd>';
	echo '
					<dd>';
	if (!empty($context['spmod_cats'])) 
	{	
		foreach($context['spmod_cats'] as $spmod_cat)
		{		
			if ($saname == 'editproc' && isset($context['spproc_curcats']) && in_array($spmod_cat['catid'], $context['spproc_curcats'])) 
				$ch = ' checked="checked" ';
			else $ch = ''; 	
			echo '
						<label for="groups_' . $spmod_cat['catid'] . '"><input type="checkbox" name="groups[]" '.$ch.' value="' . $spmod_cat['catid'] . '" id="groups_' . $spmod_cat['catid'] . '" class="input_check" />
						<span>' . $spmod_cat['name'] . '</span>
						</label><br />';
		}
		echo '
						<em>'.$txt['spmod_selectall'].'</em> <input type="checkbox" class="input_check" onclick="invertAll(this, this.form, \'groups[]\');" /><br />
						<br />
					</dd>';
	} else echo '[<i>' . $txt['spmod_nocats'] . '</i>]';						
	echo '	
				</dd>						
				</dl>
				<div class="righttext">';
	if ($saname == 'editproc')
	echo '
					<input type="hidden" value="'.$context['spproc_curid'].'" name="procid" />';
	echo '
					<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
					<input type="submit" name="add" value="' . $txt['spmod_save'] . '" onclick="return !isEmptyText(this.form.proc_name);" tabindex="11" class="button_submit" />
				</div>
			</div>
			<span class="botslice"><span></span></span>
		</div>
	</form>
</div>';
}

//Зона "Редактирование Закупки" и "Код вставки"
function template_editproc()
{
	global $scripturl, $context, $txt;
	
	writeTabs();
	ProcEditForm('editproc', 'save');
		
	echo '
<br />
<div id="manage_boards">	
	<div class="cat_bar">
		<h3 class="catbg">'.$txt['spmod_purchcode'].'</h3>
	</div>
	<div class="windowbg">
		<span class="topslice"><span></span></span>
		<div class="content">';
	$vkinviting = $txt['spmod_openpurch'] . ' "' . $context['spproc_curname'] . '"
';
	if (!empty($context['spproc_curwebsite'])) $vkinviting .= $txt['spmod_chooseonsite'] . ' ' . $context['spproc_curwebsite'];
	$vkinviting .= str_replace(
					array('{vklink}', '{topiclink}'), 
					array('https://vk.com/app5196721#' . $context['spproc_curid'], $scripturl . '/topic=' . $context['spproc_curtopic'] . '.html'),
					'
' . $txt['spmod_vkinviting']);	
	echo '
			<br />
			<dl class="settings">
			<dt>
				<strong>', $txt['spmod_vkproclink'], ':</strong><br />
				<span class="smalltext">', $txt['spmod_vkproclinkdescr'], '</span>
			</dt>
			<dd>		
				<textarea rows="10" cols="75" name="text">', $vkinviting, '</textarea>
			</dd>
			<dt>
				<strong>'.$txt['spmod_catlistcode'].':</strong><br />
				<span class="smalltext">'.$txt['spmod_catlistcodedescr'].'</span>
			</dt>
			<dd>		
				<textarea rows="10" cols="75" name="text">';
	if (!empty($context['spmod_cats'])) foreach($context['spmod_cats'] as $spmod_cat)
	{
		if (isset($context['spproc_curcats']) && in_array($spmod_cat['catid'], $context['spproc_curcats']))
			echo '
[url=', $scripturl, '?action=spmod;sa=buys;procid='.$context['spproc_curid'].';catname=', $spmod_cat['name'],';catid=', $spmod_cat['catid'],']', $spmod_cat['name'],'[/url]';
	}	
	echo '
				</textarea>
			</dd>
			<dt>
				<strong>'.$txt['spmod_tablecode'].':</strong><br />
				<span class="smalltext">'.$txt['spmod_tablecodedescr'].'</span>
			</dt>
			<dd>		
				<textarea rows="3" cols="75" name="text">[sp]', $context['spproc_curid'],'[/sp]</textarea>
			</dd>
			</dl>
		</div>
	</div>
	<span class="botslice"><span></span></span>
</div>';

	AddCopyright();
}

//Зона "Отчет по закупке"
function template_reportproc()
{
	global $scripturl, $context, $txt;
	
	writeTabs();
	echo '<div style="clear: both;">';
	template_show_list('report_list');	
	echo '</div>';
	if (!isset($context['spproc_turnover'])) $context['spproc_turnover'] = 0;
	if (!isset($context['spproc_orgsum'])) $context['spproc_orgsum'] = 0;	
	if (!isset($context['spproc_ordsum'])) $context['spproc_ordsum'] = 0;
	
	echo '<br /><table>
	<tr><td>',$txt['spmod_turnover'] ,'</td><td><strong>',$context['spproc_turnover'] . $txt['spmod_currency']  ,'</strong></td></tr>
	<tr><td>',$txt['spmod_ordersumma'] ,'</td><td><strong>',$context['spproc_ordsum'] . $txt['spmod_currency'] ,'</strong></td></tr>
	<tr><td>',$txt['spmod_c_comission'], '</td><td><strong>',$context['spproc_comission'] . $txt['spmod_currency'] ,'</strong></td></tr>
	<tr><td>',$txt['spmod_orgpercsumma'] ,'</td><td style="color:#ff0000"><strong>',$context['spproc_orgsum'] . $txt['spmod_currency'] ,'</strong></td></tr>
	</tr></table>';	

	echo '
		<div class="righttext">
			<form action="', $scripturl, '?action=spprintpage"  method="post" name="thePrintPage">';					
	$i = 0;
	if (!empty($context['report_real_name'])) foreach($context['report_real_name'] as $report_username)
	{
		echo '
			<input type="hidden" name="report_real_name[]" value="' . $report_username . '">
			<input type="hidden" name="report_summ[]" value="' . $context['report_summ'][$i] . '">
			<input type="hidden" name="report_org[]" value="' . $context['report_org'][$i] . '">
			<input type="hidden" name="report_bank[]" value="' . $context['report_bank'][$i] . '">
			<input type="hidden" name="report_tr[]" value="' . $context['report_tr'][$i] . '">
			<input type="hidden" name="report_itogo[]" value="' . $context['report_itogo'][$i] . '">
			<input type="hidden" name="report_distr[]" value="' . $context['report_distr'][$i] . '">	
			<input type="hidden" name="report_count[]" value="' . $context['report_count'][$i] . '">			
			<input type="hidden" name="report_userid[]" value="' . $context['report_userid'][$i] . '">
			<input type="hidden" name="report_payment[]" value="' . $context['report_payment'][$i] . '">			
			<input type="hidden" name="report_orgname[]" value="' . $context['report_orgname'][$i] . '">			
			<input type="hidden" name="report_orgnickname[]" value="' . $context['report_orgnickname'][$i] . '">
			<input type="hidden" name="report_procname[]" value="' . $context['report_procname'][$i] . '">						
			';
		$i++;	
	}		
	echo '	
			<input type="hidden" name="report_procid" value="' . $context['spproc_id'] . '">
			<input type="hidden" name="report_orgpercent" value="' . $context['report_orgpercent'] . '">
			<input type="hidden" name="report_bankfee" value="' . $context['report_bankfee'] . '">			
			<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
			<input type="submit" value="'.$txt['spmod_print'].'" class="button_submit" />
			</form>
		</div>';
	echo '
	<br /><div id="manage_boards">	
			<div class="cat_bar">
				<h3 class="catbg">' . $txt['spmod_pastecode'] . '</h3>
			</div>
			<div class="windowbg">
				<span class="topslice"><span></span></span>
				<div class="content">';
	echo '
	<br />
	
	<dl class="settings">
	<dt>
		<strong>' . $txt['spmod_summaryproccode'] . ':</strong><br />
		<span class="smalltext">' . $txt['spmod_summaryproccodedescr'] . '</span>
	</dt>
	<dd>		
		<textarea rows="10" cols="75" name="text">[table][tr][td][b]'.$txt['spmod_nick'].'			[/b][/td][td][b]'.$txt['spmod_count'].'		[/b][/td][td][b]'.$txt['spmod_c_summa'].'		[/b][/td][td][b]'.$txt['spmod_orgp'].'		[/b][/td][td][b]'.$txt['spmod_c_bank'].'		[/b][/td][td][b]'.$txt['spmod_c_tr'].'			[/b][/td][td][b]'.$txt['spmod_forpay'].'		[/b][/td][/tr]';
		$i = 0;
		if (!empty($context['report_real_name'])) foreach($context['report_real_name'] as $report_real_name)
		{
			echo '[tr][td][b]' . $report_real_name . '[/b][/td][td]' . $context['report_cnt'][$i] . '[/td][td]' . $context['report_summ'][$i] . '[/td][td]' . $context['report_org'][$i] . '[/td][td]' . $context['report_bank'][$i] . '[/td][td]' . $context['report_tr'][$i] . '[/td][td][b][color=red]' . $context['report_itogo'][$i] . '[/color][/b][/td]';
			$i++;
		}
		echo '[/table]</textarea>
	</dd>
	</dl>
	</div>
			</div>
			<span class="botslice"><span></span></span>
		</div>	
</div>';	
	
	AddCopyright();
}

//Зона "Покупки"
function template_buys()
{
	global $context, $txt, $scripturl, $boardurl; 
	
	if (isset($context['msg']))
		echo '
	<div class="windowbg" id="profile_success">', htmlspecialchars_decode(rawurldecode($context['msg'])), '
					</div>';
	
	if (isset($context['spmod_curproc']))
	{
		echo '
	<script src="', $boardurl, '/SPMod/jquery/external/jquery/jquery.js"></script>
	<script src="', $boardurl, '/Themes/default/scripts/zoomsl-3.0.min.js"></script>
	<script src="', $boardurl, '/Themes/default/scripts/spmod.js"></script>
	<script>
	jQuery(function(){   
		$(".goodzoom").imagezoomsl({    
			zoomrange: [3, 3]
		});
	});  
	</script>
	<form action="', $scripturl, '?action=spmod;sa=buys;procid=',$context['spmod_curproc'] ,';catid=',$context['spmod_curcat'] ,';sesc=' , $context['session_id'], '" method="post" name="theSearch">
	<div class="content">
					<dl class="settings">
						<dt>
							<img src="/Themes/default/images/buttons/search.gif" class="icon" alt="'.$txt['spmod_goodsearch'].'" /><span><label for="catname">'.$txt['spmod_goodsearch'].'   </label></span>
						<input type="text" name="good_search" size="30" class="input_text" />
						<input type="submit" value="' . $txt['spmod_goodsearchbutton'] . '" class="button_submit" />
					</dd></dl>
	</form>';
	
		template_show_list('buys_list');
	}	
	else 
		fatal_error($txt['spmod_purchiderror']);
	if ($context['spmod_curusercat']) GoodEditForm('goods', 'add');
	AddCopyright();	
}

//Зона "Парсер"
function template_parser()
{
	global $context, $scripturl, $txt; 

	writeTabs();
	echo '
<div id="manage_boards" style="clear: both;">
	<div class="cat_bar">
		<h3 class="catbg">', $txt['spmod_parserparams'], '</h3>
	</div>
	<div class="windowbg">
		<span class="topslice"><span></span></span>
		<form action="', $scripturl, '?action=spmod;sa=parse" method="post" name="theParserForm">
			<div class="content">
				<dl class="settings">
				<dt>
					<strong>'.$txt['spmod_newcatalog'].'</strong><br />
					<span class="smalltext">'.$txt['spmod_newcatalogdescr'].'</span>
				</dt>
				<dd>
					<input type="text" name="newcatname" size="30" tabindex="1" class="input_text" />
				</dd>				
				<dt>
					<strong>'.$txt['spmod_catalog'].'</strong><br />
					<span class="smalltext">'.$txt['spmod_catalogdescr'].'</span>
				</dt>
				<dd>
					<select name="catid" id="catname" tabindex="2">	
							<option value="-1"  selected="selected">' . $txt['spmod_nochoose'] . '</option>';
	if (!empty($context['spmod_cats'])) foreach($context['spmod_cats'] as $spmod_name)														
	{ 											
		echo '		
							<option value="'.$spmod_name['catid'].'" >'. $spmod_name['name'] . '</option>';
	}
	echo '			</select>
				</dd>									
				<dt>
					<strong>'.$txt['spmod_url'].'</strong><br />
					<span class="smalltext">' . $txt['spmod_urldescr'];
	foreach ($context['parsers'] as $key=>$parser)
		$parserlist[] = ' <a href="http://' . $key . '" target="_blank">' . $txt[$key] . '</a>';
	echo implode(",", $parserlist), '.				
					</span>
				</dt>
				<dd>					
					<textarea rows="8" cols="50" name="parser_url" tabindex="3"></textarea>
				</dd>						
				</dl>
				<div class="righttext">
					<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
					<input type="submit" name="add" value="' . $txt['spmod_execute'] . '" tabindex="4" class="button_submit" onclick="return !(isEmptyText(this.form.newcatname) && this.form.catid.selectedIndex == 0);"/>
				</div>
			</div>	
		</form>
		<span class="botslice"><span></span></span>
	</div>';
	
	AddCopyright();	
}

//Зона "Информация об организаторе (или участнике)"
function template_orginfo()
{
	global $context, $scripturl, $txt, $modSettings; 

	writeTabs();

	if (!isset($context['orginfo_name'])) $context['orginfo_name'] = '';
	if (!isset($context['orginfo_phone'])) $context['orginfo_phone'] = '';
	if (!isset($context['orginfo_address'])) $context['orginfo_address'] = '';					 

	echo '
<br /><div id="manage_boards" style="clear:both;">	                                                      
	<div class="cat_bar">
		<h3 class="catbg">', $txt['spmod_orginfo'], '</h3>
	</div>
	<div class="windowbg">
		<span class="topslice"><span></span></span>
		<form action="', $scripturl, '?action=spmod;sa=orginfo;do=save" method="post" name="theOrgInfoForm">
		<div class="content">
			<dl class="settings">
			<dt>
				<strong>'.$txt['spmod_orgfi'].'</strong><br />
				<span class="smalltext">'.$txt['spmod_orgfidescr'].'</span>
			</dt>
			<dd>					
				<input type="text" name="org_name" size="30" class="input_text" value="' . $context['orginfo_name'] . '"/>	
			</dd>
			<dt>
				<strong>'.$txt['spmod_orgphone'].'</strong><br />
				<span class="smalltext">'.$txt['spmod_orgphonedescr'].'</span>
			</dt>
			<dd>					
				<input type="text" name="org_phone" size="30" class="input_text" value="' . $context['orginfo_phone'] . '" />	
			</dd>																		
			<dt>
				<strong>'.$txt['spmod_distrdistr'].'</strong><br />
				<span class="smalltext">'.$txt['spmod_distrdistrdescr'].'</span>
			</dt>
			<dd>					
				<select name="org_distrib">';

	if ($context['orginfo_distrib'] == $txt['spmod_another']) $ch4 = 'selected="selected" '; else $ch4 = ' ';
	foreach(explode("\n", $modSettings['spmod_distriblist']) as $sl)
	{
		if ($context['orginfo_distrib'] == $sl) $ch = ' selected="selected" '; else $ch = ' '; 
		echo '<option value="', $sl, '"',$ch , '>',$sl,'</option>';
	}	
	echo '				
					<option value="'.$txt['spmod_another'].'"' . $ch4 . '>'.$txt['spmod_anothercomment'].'</option>
				</select>
			</dd>';
	if (isset($modSettings['spmod_addaddress'])&&($modSettings['spmod_addaddress']))
	echo '	
			<dt>
				<strong>'.$txt['spmod_orgaddress'].'</strong><br />
				<span class="smalltext">'.$txt['spmod_orgaddressdescr'].'</span>
			</dt>
			<dd>					
				<textarea name="org_address" cols="40" rows="4" class="input_text" value="' . $context['orginfo_address'] . '">'.$context['orginfo_address'].'</textarea>	
			</dd>';
	echo '				
			</dl>
			<div class="righttext">
				<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
				<input type="submit" name="save" value="' . $txt['spmod_save'] . '" class="button_submit" />
			</div>
		</div></form>';
	
	echo '
		<span class="botslice"><span></span></span>
	</div>
</div>';
	
	AddCopyright();	
}

function template_parse()
{
	global $txt;
	
	writeTabs();
	echo '<br /><center>' . $txt['spmod_done'] . '</center><br />';
	AddCopyright();	
}

function template_toxml()
{
	global $txt;

	writeTabs();
	echo '<br /><center>' . $txt['spmod_done'] . '</center><br />';
	AddCopyright();	
}

function template_fromxml()
{
	global $txt;

	writeTabs();
	echo '<div class="windowbg" id="profile_success">', $txt['spmod_done'], '</div>';
	AddCopyright();	
}

function template_fromcsv()
{
	global $txt;

	writeTabs();
	echo '<br /><center>' . $txt['spmod_done'] . '</center><br />';
	AddCopyright();	
}

function template_myproc()
{
	writeTabs();
	echo '<div style="clear: both;">';
	template_show_list('myproc_list');
	echo '</div>';
	AddCopyright();	
}

//Зона "Администрирование"
function template_spadmin()
{
	global $context, $boardurl, $user_info, $txt, $scripturl;

	writeTabs();
	
	echo ' 
	<!--	
	<link rel="stylesheet" href="', $boardurl, '/SPMod/jquery/themes/base/jquery-ui.css">
	-->
	<link rel="stylesheet" href="//code.jquery.com/ui/1.11.4/themes/smoothness/jquery-ui.css">
	<script src="', $boardurl, '/SPMod/jquery/external/jquery/jquery.js"></script>
	<script src="', $boardurl, '/SPMod/jquery/ui/widget.js"></script>
	<script src="', $boardurl, '/SPMod/jquery/ui/datepicker.js"></script>
	<script src="', $boardurl, '/SPMod/jquery/ui/i18n/datepicker.'.$user_info['language'].'.js"></script>	
	<script>
	$(function() {
		$( "#datepicker" ).datepicker({
			defaultDate: "+1w",
			changeMonth: true,
			numberOfMonths: 3,
			onClose: function( selectedDate ) {
				$( "#datepicker2" ).datepicker( "option", "minDate", selectedDate );
			}
		});
		$( "#datepicker2" ).datepicker({
			defaultDate: "+1w",
			changeMonth: true,
			numberOfMonths: 3,
			onClose: function( selectedDate ) {
				$( "#datepicker" ).datepicker( "option", "maxDate", selectedDate );
			}
		});
	});
	</script>';			
	
	$sp_statuses = array(
                 $txt['spmod_purchstat_open'],
                 $txt['spmod_purchstat_stop'],
                 $txt['spmod_purchstat_wait'],
                 $txt['spmod_purchstat_pay'],
                 $txt['spmod_purchstat_shipment'],
                 $txt['spmod_purchstat_overorder'],
                 $txt['spmod_purchstat_stopoverorder'],
                 $txt['spmod_purchstat_inway'],
                 $txt['spmod_purchstat_close'],
                 $txt['spmod_purchstat_gone'],
                 $txt['spmod_purchstat_get'],
                 $txt['spmod_purchstat_issuance'],
                 $txt['spmod_purchstat_vocation'],
				 $txt['spmod_purchstat_wasnt'],
	);
	
	echo '
	<form action="', $scripturl, '?action=spmod;sa=spadmin;sesc=' , $context['session_id'], '" method="post" name="theSPAdminDateChoose">
	<div class="content" style="clear: both;"> 
		<dl class="settings">
		<dt>
			<span>' . $txt['spmod_status'] . '</span>
			<select name="proc_status" id="proc_status">
				<option value="%">' . $txt['spmod_any'] . '</option>';
	foreach ($sp_statuses as $sp_status)
	{	
		if (strcasecmp($sp_status, $context['proc_status']) == 0)
			$ch = 'selected="selected"';
		else 
			$ch = '';
		echo '			
				<option value="', $sp_status, '" ', $ch, ' >', $sp_status, '</option>';
	}
	echo '	
			</select>	
			<span>&nbsp;' . $txt['spmod_purchasestopdate'] . $txt['spmod_datefrom'].'</span><input type="text" name="proc_start" id="datepicker" maxlength="10" size="10" tabindex="1" class="input_text" value="' .  $context['proc_start'] . '" />
			<span>' . $txt['spmod_dateto'] . '</span>
			<input type="text" name="proc_stop" id="datepicker2" maxlength="10" size="10" tabindex="2" class="input_text" value="' . $context['proc_stop'] . '" />	
			<input type="submit" value="' . $txt['spmod_choose'] . '" tabindex="3" class="button_submit" />
		</dd>
		</dl>
	</form>';	
	
	echo '
	<div style="clear: both;">
	<form action="', $scripturl, '?action=spmod;sa=delproc" method="post" enctype="multipart/form-data>';
	template_show_list('spadmin_list');
	echo '
		<div class="floatright">
			<input type="hidden" name="sc" value="' . $context['session_id'] . '" />
			<div class="additional_row" style="text-align: right;">
				<input type="submit" name="delete_spprocs" value="', $txt['spmod_delprocs'], '" onclick="return confirm(\'', $txt['spmod_delprocconfirm'], '\');" class="button_submit" />
			</div>
		</div>
	</form>
	</div>'; 	
	AddCopyright();	
}

//Зона "Помощь"
function template_help()
{
	global $txt;
	
	writeTabs();
	echo '
	<div id="manage_boards" style="clear: both;"> 
		<div class="cat_bar">
			<h3 class="catbg">', $txt['spmod_helptitle'], '</h3>
		</div>
		<div class="windowbg">
			<span class="topslice"><span></span></span>';
	echo $txt['spmod_help'];
	echo '
			<span class="botslice"><span></span></span>
		</div>
	</div>';
	AddCopyright();	
}

function AddCopyright()
{
	global $modSettings, $txt;
	
	if (!isset($modSettings['spmod_version'])) $modSettings['spmod_version'] = $txt['spmod_unknownver'];
	echo '
		<br />
		<br />
		<hr />
		<center><span class="middletext">', str_replace('{version}', $modSettings['spmod_version'], $txt['spmod_copyright']), '</span></center>';
}

?>