<?php

/*******************************************
* SPMod
* Version 1.0
* © mamavrn.ru
********************************************
* SPPrintpageMod.template.php
*******************************************/

function template_print_above()
{
	global $context, $txt;

	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"', $context['right_to_left'] ? ' dir="rtl"' : '', '>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=', $context['character_set'], '" />
		<meta name="robots" content="noindex" />
		<title>', $txt['print_page'], ' - ', $txt['spmod_customers'], '</title>
		<style type="text/css">
			body, a
			{
				color: #000;
				background: #fff;
			}
			body, td, .normaltext
			{
				font-family: Verdana, arial, helvetica, serif;
				font-size: small;
			}
			h1#title
			{
				font-size: large;
				font-weight: bold;
			}
			h2#linktree
			{
				margin: 1em 0 2.5em 0;
				font-size: small;
				font-weight: bold;
			}
		   .rightimg  
			{
				float: right; 
				margin: 7px 17px 0px 5px; 
			}
			table
			{
				empty-cells: show;
				border-collapse: collapse; 
			}			
			td, th {
				padding: 3px; 
				border: 1px solid black; 
			}				
			}
			.smalltext, .quoteheader, .codeheader
			{
				font-size: x-small;
			}
			.largetext
			{
				font-size: large;
			}
			.centertext
			{
				text-align: center;
			}
			hr
			{
				height: 1px;
				border: 0;
				color: black;
				background-color: black;
			}			
		</style>
	</head>
	<body>';
}

function template_main()
{
	global $context, $txt, $boardurl;

	$i = 0;	
	foreach ($context['report_real_name'] as $item)
	{
		echo '<div style="page-break-inside: avoid;"><table width="100%"><tr>';
		echo '
			<td width="100%">
				<h1 id="title">', $item, '</h1>
				', $txt['spprintpage_proc'], ': <b>' . $context['report_procname'][$i] . '</b><br />
				', $txt['spmod_t_orgname'], ': <b>' . $context['report_orgnickname'][$i] . '</b><br />
				', $txt['spmod_distrib'], ': <b>' . $context['report_distr'][$i] . '</b><br />
				<table width="100%">
				<tr>
				<td>',$txt['spmod_name'] ,'</td><td>',$txt['spmod_price'] ,'</td><td>',$txt['spmod_count'] ,'</td><td>',$txt['spmod_c_summa'] ,'</td><td>',$txt['spmod_orgp'] ,'</td><td>',$txt['spmod_c_bank'] ,'</td><td>',$txt['spprintpage_vsego'] ,'</td>
				</tr>';
		$koplate = 0;		
		foreach ($context['report_purchdetail'][$item] as $purchdetail)
		{		
			echo '		
					<tr>
					<td>', $purchdetail['name'], '</td><td>', $purchdetail['price'],'</td><td>', $purchdetail['purchcount'], '</td><td>', $purchdetail['summa'],'</td><td>', $purchdetail['orgsum'],'</td><td>', $purchdetail['banksum'],'</td><td>', $purchdetail['vsego'],'</td>
					</tr>';
			$koplate = $koplate + $purchdetail['vsego'];		
		}			
		echo '		
				</table><br />
				', $txt['spmod_c_tr'], ': <strong>', $context['report_tr'][$i], $txt['spmod_currency'], '</strong><br />
				', $txt['spprintpage_vsego'], ': <strong>', $koplate + $context['report_tr'][$i], $txt['spmod_currency'], '</strong><br />
				', $txt['spprintpage_waspaied'], ': <strong>', $context['report_payment'][$i], $txt['spmod_currency'], '</strong><br />
				', $txt['spmod_koplate'], ': <strong>', round($koplate + $context['report_tr'][$i] - $context['report_payment'][$i], 2), $txt['spmod_currency'], '</strong><br /><br />
				', '<p><img src="', $boardurl, '/SPMod/images/sp/splogo.png" class="rightimg"/>
				', str_replace('{boardurl}', str_replace('http://', '', $boardurl), $txt['spprintpage_subtext']), '</p>';
			echo '</tr></table></div>';
		$i++;	
	}
}

function template_print_below()
{
	echo '	
		<div id="footer" class="smalltext" style="margin-top: 20px;text-align: center;">
			', theme_copyright(), '
		</div>
	</body>
</html>';
}

?>