<?php
/*******************************************
* SPMod
* Version 1.0
* © mamavrn.ru
********************************************
* install.php
*******************************************/

	updateSettings(array('spmod_version' => '1.0 rc8'));

if (!isset($modSettings['spmod_proctemplate']))
	updateSettings(array( 
		'spmenubutton_enabled' => '1',
		'spmod_maxpercent' => '15',
		'spmod_checkbanner' => '1',
		'spmod_commission' => '0',
		'spmod_address' => '0',
		'spmod_premoderate' => '0',
		'spmod_proctemplate' => '[center][color=blue][b]{title}[/b][/color]
[i]{descr}[/i][/center]

Hi there!
My name is {name}. My phone number is {phone}.

Website: {website}
{minmode}
STOP date: {stop} 

[b]The conditions of purchase[/b]
************************************************************
For a start see general terms amd conditions of purchases [url=http://mamavrn.ru/index.php?action=announcement;aid=6]on this forum[/url].

[b]Main terms:[/b]
[list type=decimal]
[li]Organizer percentage: [color=red]{percent}%[/color][/li]
[li]Shipping: {trmode}[/li]
[li]Bank fee: {bank}%[/li]
[li]Period for distribution is 2 weeks![/li]
[li]100% prepayment using debit/credit card  or PayPal.[/li]
[li]Payment period is 2 days after STOP.[/li]
[li]Keep the payment receipts please.[/li] 
[li]Fill in your contact details in [url=/index.php?action=spmod;sa=orginfo]Member Area[/url].[/li] 
[li]You can cancel a order before STOP.[/li]
[/list]

[b]Choose the items in the catalogs or on the web site. Also you can make a order via the last row in this table.[/b]
[b][size=12pt]{catalogs}[/size][/b]

{table}

[list]
[li][i]Participation in this purchase means that the participant have read all of the above conditions and accepted them fully.[/i][/li]
[/list]


     [b]Wish you a pleasant shopping![/b]
',
		'spmod_distriblist' => 'City Center Office
Northern Office
Left Bank Office',
		)
	);

	//Catalogs			
	$columns = array(
		array(
			'name' => 'catid',
			'type' => 'smallint',
			'size' => 5,
			'auto' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 50,
		),
		array(
			'name' => 'image',
			'type' => 'tinytext',
		),
		array(
			'name' => 'description',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'count',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'orgid',
			'type' => 'mediumint',
			'size' => 9,
		),
		array(
			'name' => 'usercat',
			'type' => 'tinyint',
			'size' => 3,
		),		
	);

	$indexes = array(
   		array(
				'name' => 'catid',
      			'type' => 'primary',
      			'columns' => array('catid'),
   		)
	); 

	$tblname = '{db_prefix}spmod_category';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');
	
	//Item
	$columns = array(
		array(
			'name' => 'itemid',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 200
		),
		array(
			'name' => 'description',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'price',
			'type' => 'decimal(10,2)',
			'default' => '0.00',
		),
		array(
			'name' => 'count',
			'type' => 'smallint',
			'size' => 6,
		),
		array(
			'name' => 'image',
			'type' => 'tinytext',
			'null' => true,
		),
		array(
			'name' => 'catid',
			'type' => 'smallint',
			'size' => 6,
		),		
		array(
			'name' => 'articul',
			'type' => 'varchar',
			'size' => 50,
		),		
		array(
			'name' => 'link',
			'type' => 'tinytext',
		),				
		array(
			'name' => 'param1',
			'type' => 'smallint',
			'size' => 6,
		),						
		array(
			'name' => 'param2',
			'type' => 'smallint',
			'size' => 6,
		),		
		array(
			'name' => 'status',
			'type' => 'tinyint',
			'size' => 1,
		),
		array(
			'name' => 'linecount',
			'type' => 'mediumint',
			'size' => 9,
			'default' => '0',
		),
		array(
			'name' => 'params',
			'type' => 'varchar',
			'size' => 50,
		),		
		array(
			'name' => 'linecaption',
			'type' => 'varchar',
			'size' => 50,
		),		
	);

	$indexes = array(
   		array(
				'name' => 'itemid',
      			'type' => 'primary',
      			'columns' => array('itemid'),
   		)
	); 

	$tblname = '{db_prefix}spmod_item';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');	
	
	//ItemParam
	$columns = array(
		array(
			'name' => 'paramid',
			'type' => 'smallint',
			'size' => 6,
			'auto' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 50,
			'null' => true,
		),
		array(
			'name' => 'caption',
			'type' => 'varchar',
			'size' => 50,
			'null' => true,
		),
		array(
			'name' => 'params',
			'type' => 'varchar',
			'size' => 50,
			'null' => true,
		),
		array(
			'name' => 'orgid',
			'type' => 'mediumint',
			'size' => 9,
			'null' => true,
		),
		array(
			'name' => 'linecount',
			'type' => 'mediumint',
			'size' => 9,
			'null' => true,
		),	
	);

	$indexes = array(
   		array(
				'name' => 'paramid',
      			'type' => 'primary',
      			'columns' => array('paramid'),
   		)
	); 

	$tblname = '{db_prefix}spmod_itemparam';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');		
	
	
	//Proc
	$columns = array(
		array(
			'name' => 'procid',
			'type' => 'smallint',
			'size' => 5,
			'auto' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 100,
		),
		array(
			'name' => 'description',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'website',
			'type' => 'varchar',
			'size' => 40,
			'null' => true,
		),		
		array(
			'name' => 'startdate',
			'type' => 'int',
			'size' => 11,
			'null' => true,
		),
		array(
			'name' => 'stopdate',
			'type' => 'int',
			'size' => 11,
			'null' => true,
		),
		array(
			'name' => 'status',
			'type' => 'varchar',
			'size' => 20,
			'null' => true,
		),
		array(
			'name' => 'orgid',
			'type' => 'mediumint',
			'size' => 9,
		),		
		array(
			'name' => 'orgpercent',
			'type' => 'smallint',
			'size' => 6,
			'null' => true,
		),				
		array(
			'name' => 'topicid',
			'type' => 'mediumint',
			'size' => 9,
			'null' => true,
		),				
		array(
			'name' => 'minsum',
			'type' => 'decimal(10,2)',
			'null' => true,
		),		
		array(
			'name' => 'cursum',
			'type' => 'decimal(10,2)',
			'default' => '0.00',
		),	
		array(
			'name' => 'bankfee',
			'type' => 'float',
			'null' => true,
		),						
		array(
			'name' => 'tr',
			'type' => 'decimal(10,2)',
			'default' => '0.00',
		),		
		array(
			'name' => 'tr_mode',
			'type' => 'tinyint',
			'size' => 1,			
		),
		array(
			'name' => 'minsum_mode',
			'type' => 'tinyint',
			'size' => 1,			
		),
		array(
			'name' => 'banner',
			'type' => 'tinytext',		
		),	
		array(
			'name' => 'buyout',
			'type' => 'mediumint',
			'size' => 9,
			'null' => true,
		),		
	);

	$indexes = array(
   		array(
				'name' => 'procid',
      			'type' => 'primary',
      			'columns' => array('procid'),
   		)
	); 

	$tblname = '{db_prefix}spmod_proc';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');	
	
	//ProcCat
	$columns = array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'procid',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'catid',
			'type' => 'int',
			'size' => 10,
		),
	);

	$indexes = array(
   		array(
				'name' => 'id',
      			'type' => 'primary',
      			'columns' => array('id'),
   		)
	); 

	$tblname = '{db_prefix}spmod_proccat';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');		
	
	//PurchHis
	$columns = array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'itemid',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'userid',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'procid',
			'type' => 'int',
			'size' => 11,
		),		
		array(
			'name' => 'param',
			'type' => 'varchar',
			'size' => 50,
		),
		array(
			'name' => 'status',
			'type' => 'int',
			'size' => 10,
		),		
		array(
			'name' => 'orgpercent',
			'type' => 'smallint',
			'size' => 6,
			'null' => true,
		),	
		array(
			'name' => 'lineid',
			'type' => 'int',
			'size' => 11,
		),			
	);

	$indexes = array(
   		array(
				'name' => 'id',
      			'type' => 'primary',
      			'columns' => array('id'),
   		)
	); 

	$tblname = '{db_prefix}spmod_purchHis';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');	

	//OrgInfo
	$columns = array(
		array(
			'name' => 'orgid',
			'type' => 'mediumint',
			'size' => 9,
		),
		array(
			'name' => 'orgname',
			'type' => 'varchar',
			'size' => 50,
		),
		array(
			'name' => 'orgphone',
			'type' => 'varchar',
			'size' => 50,
		),
		array(
			'name' => 'distribution',
			'type' => 'varchar',
			'size' => 30,
		),	
		array(
			'name' => 'bonuscard',
			'type' => 'int',
			'size' => 11,
		),		
	);

	$indexes = array(
   		array(
				'name' => 'orgid',
      			'type' => 'primary',
      			'columns' => array('orgid'),
   		)
	); 

	$tblname = '{db_prefix}spmod_orginfo';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');		

	//UserProc
	$columns = array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'userid',
			'type' => 'mediumint',
			'size' => 9,
		),
		array(
			'name' => 'procid',
			'type' => 'smallint',
			'size' => 5,
		),
		array(
			'name' => 'payment',
			'type' => 'decimal(10,2)',
			'default' => '0.00',
		),	
		array(
			'name' => 'paymentdate',
			'type' => 'int',
			'size' => 11,
		),		
	);

	$indexes = array(
   		array(
				'name' => 'id',
      			'type' => 'primary',
      			'columns' => array('id'),
   		)
	); 

	$tblname = '{db_prefix}spmod_userproc';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');		
	
	//PurchLines
	$columns = array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'linecount',
			'type' => 'mediumint',
			'size' => 9,
		),
		array(
			'name' => 'linecurrent',
			'type' => 'mediumint',
			'size' => 9,
		),
		array(
			'name' => 'paramavail',
			'type' => 'varchar',
			'size' => 255,
		),		
	);

	$indexes = array(
   		array(
				'name' => 'id',
      			'type' => 'primary',
      			'columns' => array('id'),
   		)
	); 

	$tblname = '{db_prefix}spmod_purchLines';	 
	$smcFunc['db_create_table']($tblname, $columns, $indexes, array(), 'update');		
	
	//Обновление БД до версии 1.0 rc4 
	
	//item
	$tblname = '{db_prefix}spmod_item';	
	$columnname = 'price';		
	$column_info = array('type' => 'decimal(10,2)');
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);
	
	$columns = array(
		array(
			'name' => 'linecount',
			'type' => 'mediumint',
			'size' => 9,
			'default' => '0',
		),
		array(
			'name' => 'params',
			'type' => 'varchar',
			'size' => 50,
		),		
		array(
			'name' => 'linecaption',
			'type' => 'varchar',
			'size' => 50,
		),		
	);	
	foreach ($columns as $column) $smcFunc['db_add_column']($tblname, $column);
	
	//itemparam
	$tblname = '{db_prefix}spmod_itemparam';	
	$columns = array(
		array(
			'name' => 'linecount',
			'type' => 'mediumint',
			'size' => 9,
			'null' => true,
		),		
	);	
	foreach ($columns as $column) $smcFunc['db_add_column']($tblname, $column);
	//spmod_proc
	$tblname = '{db_prefix}spmod_proc';	
	$columnname = 'minsum';		
	$column_info = array('type' => 'decimal(10,2)');
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);
	$columnname = 'cursum';		
	$column_info = array('type' => 'decimal(10,2)');
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);
	$columnname = 'tr';		
	$column_info = array('type' => 'decimal(10,2)');
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);

	$columns = array(
		array(
			'name' => 'buyout',
			'type' => 'mediumint',
			'size' => 9,
			'null' => true,
		),	
	);	
	foreach ($columns as $column) $smcFunc['db_add_column']($tblname, $column);
	
	//userproc
	$tblname = '{db_prefix}spmod_userproc';	
	$columnname = 'payment';		
	$column_info = array('type' => 'decimal(10,2)');
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);	
	
	$columnname = 'id';		
	$column_info = array('auto' => true);
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);		
	
	//purchHis
	$tblname = '{db_prefix}spmod_purchHis';
	$columns = array(
		array(
			'name' => 'lineid',
			'type' => 'int',
			'size' => 11,
		),
	);	
	foreach ($columns as $column) $smcFunc['db_add_column']($tblname, $column);
	
	//Обновление БД до версии 1.0 rc6
	//spmod_orginfo
	$tblname = '{db_prefix}spmod_orginfo';			
	$columns = array(
		array(
			'name' => 'address',
			'type' => 'tinytext',
		),	
	);	
	foreach ($columns as $column) $smcFunc['db_add_column']($tblname, $column);
	
	$tblname = '{db_prefix}spmod_purchHis';			
	$column = array(
		'name' => 'tr',
		'type' => 'decimal(10,2)',
		'default' => '0.00',			
	);	
	$smcFunc['db_add_column']($tblname, $column);	
	
	//Обновление БД до версии 1.0 rc8
	//spmod_itemparam
	$tblname = '{db_prefix}spmod_itemparam';				
	$columnname = 'params';		
	$column_info = array('name' => 'params', 'type' => 'text', 'size' => '1024');
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);
	
	//spmod_item
	$tblname = '{db_prefix}spmod_item';				
	$columnname = 'params';		
	$column_info = array('name' => 'params', 'type' => 'text', 'size' => '1024');
	$smcFunc['db_change_column']($tblname, $columnname, $column_info);	

	//spmod_orginfo
	$tblname = '{db_prefix}spmod_orginfo';			
	$column = array(
		'name' => 'requisites',
		'type' => 'tinytext',
	);	
	$smcFunc['db_add_column']($tblname, $column);

	
?>